
#include "CondFormats/Alignment/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void AlignTransform::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-translation", m_translation);
    ar & boost::serialization::make_nvp("m-eulerAngles", m_eulerAngles);
    ar & boost::serialization::make_nvp("m-rawId", m_rawId);
}
COND_SERIALIZATION_INSTANTIATE(AlignTransform);

template <class Archive>
void AlignTransformError::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-Parameters", m_Parameters);
    ar & boost::serialization::make_nvp("m-rawId", m_rawId);
}
COND_SERIALIZATION_INSTANTIATE(AlignTransformError);

template <class Archive>
void AlignTransformErrorExtended::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-Parameters", m_Parameters);
    ar & boost::serialization::make_nvp("m-rawId", m_rawId);
}
COND_SERIALIZATION_INSTANTIATE(AlignTransformErrorExtended);

template <class Archive>
void AlignmentErrors::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-alignError", m_alignError);
}
COND_SERIALIZATION_INSTANTIATE(AlignmentErrors);

template <class Archive>
void AlignmentErrorsExtended::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-alignError", m_alignError);
}
COND_SERIALIZATION_INSTANTIATE(AlignmentErrorsExtended);

template <class Archive>
void AlignmentSurfaceDeformations::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-parameters", m_parameters);
    ar & boost::serialization::make_nvp("m-items", m_items);
}
COND_SERIALIZATION_INSTANTIATE(AlignmentSurfaceDeformations);

template <class Archive>
void AlignmentSurfaceDeformations::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-rawId", m_rawId);
    ar & boost::serialization::make_nvp("m-parametrizationType", m_parametrizationType);
    ar & boost::serialization::make_nvp("m-index", m_index);
}
COND_SERIALIZATION_INSTANTIATE(AlignmentSurfaceDeformations::Item);

template <class Archive>
void Alignments::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-align", m_align);
}
COND_SERIALIZATION_INSTANTIATE(Alignments);

template <class Archive>
void SurveyError::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-structureType", m_structureType);
    ar & boost::serialization::make_nvp("m-rawId", m_rawId);
    ar & boost::serialization::make_nvp("m-errors", m_errors);
}
COND_SERIALIZATION_INSTANTIATE(SurveyError);

template <class Archive>
void SurveyErrors::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-surveyErrors", m_surveyErrors);
}
COND_SERIALIZATION_INSTANTIATE(SurveyErrors);

