
#include "CondFormats/BeamSpotObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void BeamSpotObjects::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("position-", position_);
    ar & boost::serialization::make_nvp("sigmaZ-", sigmaZ_);
    ar & boost::serialization::make_nvp("beamwidthX-", beamwidthX_);
    ar & boost::serialization::make_nvp("beamwidthY-", beamwidthY_);
    ar & boost::serialization::make_nvp("beamwidthXError-", beamwidthXError_);
    ar & boost::serialization::make_nvp("beamwidthYError-", beamwidthYError_);
    ar & boost::serialization::make_nvp("dxdz-", dxdz_);
    ar & boost::serialization::make_nvp("dydz-", dydz_);
    ar & boost::serialization::make_nvp("covariance-", covariance_);
    ar & boost::serialization::make_nvp("type-", type_);
    ar & boost::serialization::make_nvp("emittanceX-", emittanceX_);
    ar & boost::serialization::make_nvp("emittanceY-", emittanceY_);
    ar & boost::serialization::make_nvp("betaStar-", betaStar_);
}
COND_SERIALIZATION_INSTANTIATE(BeamSpotObjects);

template <class Archive>
void SimBeamSpotObjects::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fX0", fX0);
    ar & boost::serialization::make_nvp("fY0", fY0);
    ar & boost::serialization::make_nvp("fZ0", fZ0);
    ar & boost::serialization::make_nvp("fSigmaZ", fSigmaZ);
    ar & boost::serialization::make_nvp("fbetastar", fbetastar);
    ar & boost::serialization::make_nvp("femittance", femittance);
    ar & boost::serialization::make_nvp("fPhi", fPhi);
    ar & boost::serialization::make_nvp("fAlpha", fAlpha);
    ar & boost::serialization::make_nvp("fTimeOffset", fTimeOffset);
}
COND_SERIALIZATION_INSTANTIATE(SimBeamSpotObjects);

