
#include "CondFormats/CSCObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void CSCBadChambers::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("numberOfBadChambers", numberOfBadChambers);
    ar & boost::serialization::make_nvp("chambers", chambers);
}
COND_SERIALIZATION_INSTANTIATE(CSCBadChambers);

template <class Archive>
void CSCBadStrips::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("numberOfBadChannels", numberOfBadChannels);
    ar & boost::serialization::make_nvp("chambers", chambers);
    ar & boost::serialization::make_nvp("channels", channels);
}
COND_SERIALIZATION_INSTANTIATE(CSCBadStrips);

template <class Archive>
void CSCBadStrips::BadChamber::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("chamber-index", chamber_index);
    ar & boost::serialization::make_nvp("pointer", pointer);
    ar & boost::serialization::make_nvp("bad-channels", bad_channels);
}
COND_SERIALIZATION_INSTANTIATE(CSCBadStrips::BadChamber);

template <class Archive>
void CSCBadStrips::BadChannel::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("layer", layer);
    ar & boost::serialization::make_nvp("channel", channel);
    ar & boost::serialization::make_nvp("flag1", flag1);
    ar & boost::serialization::make_nvp("flag2", flag2);
    ar & boost::serialization::make_nvp("flag3", flag3);
}
COND_SERIALIZATION_INSTANTIATE(CSCBadStrips::BadChannel);

template <class Archive>
void CSCBadWires::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("numberOfBadChannels", numberOfBadChannels);
    ar & boost::serialization::make_nvp("chambers", chambers);
    ar & boost::serialization::make_nvp("channels", channels);
}
COND_SERIALIZATION_INSTANTIATE(CSCBadWires);

template <class Archive>
void CSCBadWires::BadChamber::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("chamber-index", chamber_index);
    ar & boost::serialization::make_nvp("pointer", pointer);
    ar & boost::serialization::make_nvp("bad-channels", bad_channels);
}
COND_SERIALIZATION_INSTANTIATE(CSCBadWires::BadChamber);

template <class Archive>
void CSCBadWires::BadChannel::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("layer", layer);
    ar & boost::serialization::make_nvp("channel", channel);
    ar & boost::serialization::make_nvp("flag1", flag1);
    ar & boost::serialization::make_nvp("flag2", flag2);
    ar & boost::serialization::make_nvp("flag3", flag3);
}
COND_SERIALIZATION_INSTANTIATE(CSCBadWires::BadChannel);

template <class Archive>
void CSCChamberIndex::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ch-index", ch_index);
}
COND_SERIALIZATION_INSTANTIATE(CSCChamberIndex);

template <class Archive>
void CSCChamberMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ch-map", ch_map);
}
COND_SERIALIZATION_INSTANTIATE(CSCChamberMap);

template <class Archive>
void CSCChamberTimeCorrections::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("factor-precision", factor_precision);
    ar & boost::serialization::make_nvp("chamberCorrections", chamberCorrections);
}
COND_SERIALIZATION_INSTANTIATE(CSCChamberTimeCorrections);

template <class Archive>
void CSCChamberTimeCorrections::ChamberTimeCorrections::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cfeb-length", cfeb_length);
    ar & boost::serialization::make_nvp("cfeb-rev", cfeb_rev);
    ar & boost::serialization::make_nvp("alct-length", alct_length);
    ar & boost::serialization::make_nvp("alct-rev", alct_rev);
    ar & boost::serialization::make_nvp("cfeb-tmb-skew-delay", cfeb_tmb_skew_delay);
    ar & boost::serialization::make_nvp("cfeb-timing-corr", cfeb_timing_corr);
    ar & boost::serialization::make_nvp("cfeb-cable-delay", cfeb_cable_delay);
    ar & boost::serialization::make_nvp("anode-bx-offset", anode_bx_offset);
}
COND_SERIALIZATION_INSTANTIATE(CSCChamberTimeCorrections::ChamberTimeCorrections);

template <class Archive>
void CSCCrateMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("crate-map", crate_map);
}
COND_SERIALIZATION_INSTANTIATE(CSCCrateMap);

template <class Archive>
void CSCDBChipSpeedCorrection::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("factor-speedCorr", factor_speedCorr);
    ar & boost::serialization::make_nvp("chipSpeedCorr", chipSpeedCorr);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBChipSpeedCorrection);

template <class Archive>
void CSCDBChipSpeedCorrection::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("speedCorr", speedCorr);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBChipSpeedCorrection::Item);

template <class Archive>
void CSCDBCrosstalk::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("factor-slope", factor_slope);
    ar & boost::serialization::make_nvp("factor-intercept", factor_intercept);
    ar & boost::serialization::make_nvp("crosstalk", crosstalk);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBCrosstalk);

template <class Archive>
void CSCDBCrosstalk::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("xtalk-slope-right", xtalk_slope_right);
    ar & boost::serialization::make_nvp("xtalk-intercept-right", xtalk_intercept_right);
    ar & boost::serialization::make_nvp("xtalk-slope-left", xtalk_slope_left);
    ar & boost::serialization::make_nvp("xtalk-intercept-left", xtalk_intercept_left);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBCrosstalk::Item);

template <class Archive>
void CSCDBGains::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("factor-gain", factor_gain);
    ar & boost::serialization::make_nvp("gains", gains);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBGains);

template <class Archive>
void CSCDBGains::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("gain-slope", gain_slope);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBGains::Item);

template <class Archive>
void CSCDBGasGainCorrection::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("gasGainCorr", gasGainCorr);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBGasGainCorrection);

template <class Archive>
void CSCDBGasGainCorrection::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("gainCorr", gainCorr);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBGasGainCorrection::Item);

template <class Archive>
void CSCDBL1TPParameters::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-alct-fifo-tbins", m_alct_fifo_tbins);
    ar & boost::serialization::make_nvp("m-alct-fifo-pretrig", m_alct_fifo_pretrig);
    ar & boost::serialization::make_nvp("m-alct-drift-delay", m_alct_drift_delay);
    ar & boost::serialization::make_nvp("m-alct-nplanes-hit-pretrig", m_alct_nplanes_hit_pretrig);
    ar & boost::serialization::make_nvp("m-alct-nplanes-hit-accel-pretrig", m_alct_nplanes_hit_accel_pretrig);
    ar & boost::serialization::make_nvp("m-alct-nplanes-hit-pattern", m_alct_nplanes_hit_pattern);
    ar & boost::serialization::make_nvp("m-alct-nplanes-hit-accel-pattern", m_alct_nplanes_hit_accel_pattern);
    ar & boost::serialization::make_nvp("m-alct-trig-mode", m_alct_trig_mode);
    ar & boost::serialization::make_nvp("m-alct-accel-mode", m_alct_accel_mode);
    ar & boost::serialization::make_nvp("m-alct-l1a-window-width", m_alct_l1a_window_width);
    ar & boost::serialization::make_nvp("m-clct-fifo-tbins", m_clct_fifo_tbins);
    ar & boost::serialization::make_nvp("m-clct-fifo-pretrig", m_clct_fifo_pretrig);
    ar & boost::serialization::make_nvp("m-clct-hit-persist", m_clct_hit_persist);
    ar & boost::serialization::make_nvp("m-clct-drift-delay", m_clct_drift_delay);
    ar & boost::serialization::make_nvp("m-clct-nplanes-hit-pretrig", m_clct_nplanes_hit_pretrig);
    ar & boost::serialization::make_nvp("m-clct-nplanes-hit-pattern", m_clct_nplanes_hit_pattern);
    ar & boost::serialization::make_nvp("m-clct-pid-thresh-pretrig", m_clct_pid_thresh_pretrig);
    ar & boost::serialization::make_nvp("m-clct-min-separation", m_clct_min_separation);
    ar & boost::serialization::make_nvp("m-mpc-block-me1a", m_mpc_block_me1a);
    ar & boost::serialization::make_nvp("m-alct-trig-enable", m_alct_trig_enable);
    ar & boost::serialization::make_nvp("m-clct-trig-enable", m_clct_trig_enable);
    ar & boost::serialization::make_nvp("m-match-trig-enable", m_match_trig_enable);
    ar & boost::serialization::make_nvp("m-match-trig-window-size", m_match_trig_window_size);
    ar & boost::serialization::make_nvp("m-tmb-l1a-window-size", m_tmb_l1a_window_size);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBL1TPParameters);

template <class Archive>
void CSCDBNoiseMatrix::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("factor-noise", factor_noise);
    ar & boost::serialization::make_nvp("matrix", matrix);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBNoiseMatrix);

template <class Archive>
void CSCDBNoiseMatrix::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("elem33", elem33);
    ar & boost::serialization::make_nvp("elem34", elem34);
    ar & boost::serialization::make_nvp("elem35", elem35);
    ar & boost::serialization::make_nvp("elem44", elem44);
    ar & boost::serialization::make_nvp("elem45", elem45);
    ar & boost::serialization::make_nvp("elem46", elem46);
    ar & boost::serialization::make_nvp("elem55", elem55);
    ar & boost::serialization::make_nvp("elem56", elem56);
    ar & boost::serialization::make_nvp("elem57", elem57);
    ar & boost::serialization::make_nvp("elem66", elem66);
    ar & boost::serialization::make_nvp("elem67", elem67);
    ar & boost::serialization::make_nvp("elem77", elem77);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBNoiseMatrix::Item);

template <class Archive>
void CSCDBPedestals::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("factor-ped", factor_ped);
    ar & boost::serialization::make_nvp("factor-rms", factor_rms);
    ar & boost::serialization::make_nvp("pedestals", pedestals);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBPedestals);

template <class Archive>
void CSCDBPedestals::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ped", ped);
    ar & boost::serialization::make_nvp("rms", rms);
}
COND_SERIALIZATION_INSTANTIATE(CSCDBPedestals::Item);

template <class Archive>
void CSCDDUMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ddu-map", ddu_map);
}
COND_SERIALIZATION_INSTANTIATE(CSCDDUMap);

template <class Archive>
void CSCGains::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("gains", gains);
}
COND_SERIALIZATION_INSTANTIATE(CSCGains);

template <class Archive>
void CSCGains::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("gain-slope", gain_slope);
    ar & boost::serialization::make_nvp("gain-intercept", gain_intercept);
    ar & boost::serialization::make_nvp("gain-chi2", gain_chi2);
}
COND_SERIALIZATION_INSTANTIATE(CSCGains::Item);

template <class Archive>
void CSCIdentifier::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("identifier", identifier);
}
COND_SERIALIZATION_INSTANTIATE(CSCIdentifier);

template <class Archive>
void CSCIdentifier::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CSCid", CSCid);
}
COND_SERIALIZATION_INSTANTIATE(CSCIdentifier::Item);

template <class Archive>
void CSCL1TPParameters::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-alct-fifo-tbins", m_alct_fifo_tbins);
    ar & boost::serialization::make_nvp("m-alct-fifo-pretrig", m_alct_fifo_pretrig);
    ar & boost::serialization::make_nvp("m-alct-drift-delay", m_alct_drift_delay);
    ar & boost::serialization::make_nvp("m-alct-nplanes-hit-pretrig", m_alct_nplanes_hit_pretrig);
    ar & boost::serialization::make_nvp("m-alct-nplanes-hit-accel-pretrig", m_alct_nplanes_hit_accel_pretrig);
    ar & boost::serialization::make_nvp("m-alct-nplanes-hit-pattern", m_alct_nplanes_hit_pattern);
    ar & boost::serialization::make_nvp("m-alct-nplanes-hit-accel-pattern", m_alct_nplanes_hit_accel_pattern);
    ar & boost::serialization::make_nvp("m-alct-trig-mode", m_alct_trig_mode);
    ar & boost::serialization::make_nvp("m-alct-accel-mode", m_alct_accel_mode);
    ar & boost::serialization::make_nvp("m-alct-l1a-window-width", m_alct_l1a_window_width);
    ar & boost::serialization::make_nvp("m-clct-fifo-tbins", m_clct_fifo_tbins);
    ar & boost::serialization::make_nvp("m-clct-fifo-pretrig", m_clct_fifo_pretrig);
    ar & boost::serialization::make_nvp("m-clct-hit-persist", m_clct_hit_persist);
    ar & boost::serialization::make_nvp("m-clct-drift-delay", m_clct_drift_delay);
    ar & boost::serialization::make_nvp("m-clct-nplanes-hit-pretrig", m_clct_nplanes_hit_pretrig);
    ar & boost::serialization::make_nvp("m-clct-nplanes-hit-pattern", m_clct_nplanes_hit_pattern);
    ar & boost::serialization::make_nvp("m-clct-pid-thresh-pretrig", m_clct_pid_thresh_pretrig);
    ar & boost::serialization::make_nvp("m-clct-min-separation", m_clct_min_separation);
}
COND_SERIALIZATION_INSTANTIATE(CSCL1TPParameters);

template <class Archive>
void CSCMapItem::serialize(Archive & ar, const unsigned int)
{
}
COND_SERIALIZATION_INSTANTIATE(CSCMapItem);

template <class Archive>
void CSCMapItem::MapItem::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("chamberLabel", chamberLabel);
    ar & boost::serialization::make_nvp("chamberId", chamberId);
    ar & boost::serialization::make_nvp("endcap", endcap);
    ar & boost::serialization::make_nvp("station", station);
    ar & boost::serialization::make_nvp("ring", ring);
    ar & boost::serialization::make_nvp("chamber", chamber);
    ar & boost::serialization::make_nvp("cscIndex", cscIndex);
    ar & boost::serialization::make_nvp("layerIndex", layerIndex);
    ar & boost::serialization::make_nvp("stripIndex", stripIndex);
    ar & boost::serialization::make_nvp("anodeIndex", anodeIndex);
    ar & boost::serialization::make_nvp("strips", strips);
    ar & boost::serialization::make_nvp("anodes", anodes);
    ar & boost::serialization::make_nvp("crateLabel", crateLabel);
    ar & boost::serialization::make_nvp("crateid", crateid);
    ar & boost::serialization::make_nvp("sector", sector);
    ar & boost::serialization::make_nvp("trig-sector", trig_sector);
    ar & boost::serialization::make_nvp("dmb", dmb);
    ar & boost::serialization::make_nvp("cscid", cscid);
    ar & boost::serialization::make_nvp("ddu", ddu);
    ar & boost::serialization::make_nvp("ddu-input", ddu_input);
    ar & boost::serialization::make_nvp("slink", slink);
    ar & boost::serialization::make_nvp("fed-crate", fed_crate);
    ar & boost::serialization::make_nvp("ddu-slot", ddu_slot);
    ar & boost::serialization::make_nvp("dcc-fifo", dcc_fifo);
    ar & boost::serialization::make_nvp("fiber-crate", fiber_crate);
    ar & boost::serialization::make_nvp("fiber-pos", fiber_pos);
    ar & boost::serialization::make_nvp("fiber-socket", fiber_socket);
}
COND_SERIALIZATION_INSTANTIATE(CSCMapItem::MapItem);

template <class Archive>
void CSCNoiseMatrix::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("matrix", matrix);
}
COND_SERIALIZATION_INSTANTIATE(CSCNoiseMatrix);

template <class Archive>
void CSCNoiseMatrix::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("elem33", elem33);
    ar & boost::serialization::make_nvp("elem34", elem34);
    ar & boost::serialization::make_nvp("elem35", elem35);
    ar & boost::serialization::make_nvp("elem44", elem44);
    ar & boost::serialization::make_nvp("elem45", elem45);
    ar & boost::serialization::make_nvp("elem46", elem46);
    ar & boost::serialization::make_nvp("elem55", elem55);
    ar & boost::serialization::make_nvp("elem56", elem56);
    ar & boost::serialization::make_nvp("elem57", elem57);
    ar & boost::serialization::make_nvp("elem66", elem66);
    ar & boost::serialization::make_nvp("elem67", elem67);
    ar & boost::serialization::make_nvp("elem77", elem77);
}
COND_SERIALIZATION_INSTANTIATE(CSCNoiseMatrix::Item);

template <class Archive>
void CSCPedestals::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("pedestals", pedestals);
}
COND_SERIALIZATION_INSTANTIATE(CSCPedestals);

template <class Archive>
void CSCPedestals::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ped", ped);
    ar & boost::serialization::make_nvp("rms", rms);
}
COND_SERIALIZATION_INSTANTIATE(CSCPedestals::Item);

template <class Archive>
void CSCReadoutMapping::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mapping-", mapping_);
    ar & boost::serialization::make_nvp("sw2hw-", sw2hw_);
}
COND_SERIALIZATION_INSTANTIATE(CSCReadoutMapping);

template <class Archive>
void CSCReadoutMapping::CSCLabel::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("endcap-", endcap_);
    ar & boost::serialization::make_nvp("station-", station_);
    ar & boost::serialization::make_nvp("ring-", ring_);
    ar & boost::serialization::make_nvp("chamber-", chamber_);
    ar & boost::serialization::make_nvp("vmecrate-", vmecrate_);
    ar & boost::serialization::make_nvp("dmb-", dmb_);
    ar & boost::serialization::make_nvp("tmb-", tmb_);
    ar & boost::serialization::make_nvp("tsector-", tsector_);
    ar & boost::serialization::make_nvp("cscid-", cscid_);
    ar & boost::serialization::make_nvp("ddu-", ddu_);
    ar & boost::serialization::make_nvp("dcc-", dcc_);
}
COND_SERIALIZATION_INSTANTIATE(CSCReadoutMapping::CSCLabel);

template <class Archive>
void CSCTriggerMapping::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mapping-", mapping_);
}
COND_SERIALIZATION_INSTANTIATE(CSCTriggerMapping);

template <class Archive>
void CSCTriggerMapping::CSCTriggerConnection::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("rendcap-", rendcap_);
    ar & boost::serialization::make_nvp("rstation-", rstation_);
    ar & boost::serialization::make_nvp("rsector-", rsector_);
    ar & boost::serialization::make_nvp("rsubsector-", rsubsector_);
    ar & boost::serialization::make_nvp("rcscid-", rcscid_);
    ar & boost::serialization::make_nvp("cendcap-", cendcap_);
    ar & boost::serialization::make_nvp("cstation-", cstation_);
    ar & boost::serialization::make_nvp("csector-", csector_);
    ar & boost::serialization::make_nvp("csubsector-", csubsector_);
    ar & boost::serialization::make_nvp("ccscid-", ccscid_);
}
COND_SERIALIZATION_INSTANTIATE(CSCTriggerMapping::CSCTriggerConnection);

template <class Archive>
void CSCcrosstalk::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("crosstalk", crosstalk);
}
COND_SERIALIZATION_INSTANTIATE(CSCcrosstalk);

template <class Archive>
void CSCcrosstalk::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("xtalk-slope-right", xtalk_slope_right);
    ar & boost::serialization::make_nvp("xtalk-intercept-right", xtalk_intercept_right);
    ar & boost::serialization::make_nvp("xtalk-chi2-right", xtalk_chi2_right);
    ar & boost::serialization::make_nvp("xtalk-slope-left", xtalk_slope_left);
    ar & boost::serialization::make_nvp("xtalk-intercept-left", xtalk_intercept_left);
    ar & boost::serialization::make_nvp("xtalk-chi2-left", xtalk_chi2_left);
}
COND_SERIALIZATION_INSTANTIATE(CSCcrosstalk::Item);

template <class Archive>
void cscdqm::DCSAddressType::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("iendcap", iendcap);
    ar & boost::serialization::make_nvp("istation", istation);
    ar & boost::serialization::make_nvp("iring", iring);
    ar & boost::serialization::make_nvp("ichamber", ichamber);
}
COND_SERIALIZATION_INSTANTIATE(cscdqm::DCSAddressType);

template <class Archive>
void cscdqm::DCSData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("temp-meas", temp_meas);
    ar & boost::serialization::make_nvp("hvv-meas", hvv_meas);
    ar & boost::serialization::make_nvp("lvv-meas", lvv_meas);
    ar & boost::serialization::make_nvp("lvi-meas", lvi_meas);
    ar & boost::serialization::make_nvp("temp-mode", temp_mode);
    ar & boost::serialization::make_nvp("hvv-mode", hvv_mode);
    ar & boost::serialization::make_nvp("lvv-mode", lvv_mode);
    ar & boost::serialization::make_nvp("lvi-mode", lvi_mode);
    ar & boost::serialization::make_nvp("iov", iov);
    ar & boost::serialization::make_nvp("last-change", last_change);
}
COND_SERIALIZATION_INSTANTIATE(cscdqm::DCSData);

template <class Archive>
void cscdqm::HVVMeasType::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("adr", adr);
    ar & boost::serialization::make_nvp("position", position);
    ar & boost::serialization::make_nvp("value", value);
}
COND_SERIALIZATION_INSTANTIATE(cscdqm::HVVMeasType);

template <class Archive>
void cscdqm::LVIMeasType::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("adr", adr);
    ar & boost::serialization::make_nvp("board", board);
    ar & boost::serialization::make_nvp("boardId", boardId);
    ar & boost::serialization::make_nvp("nominal-v", nominal_v);
    ar & boost::serialization::make_nvp("value", value);
}
COND_SERIALIZATION_INSTANTIATE(cscdqm::LVIMeasType);

template <class Archive>
void cscdqm::LVVMeasType::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("adr", adr);
    ar & boost::serialization::make_nvp("board", board);
    ar & boost::serialization::make_nvp("boardId", boardId);
    ar & boost::serialization::make_nvp("nominal-v", nominal_v);
}
COND_SERIALIZATION_INSTANTIATE(cscdqm::LVVMeasType);

template <class Archive>
void cscdqm::TempMeasType::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("adr", adr);
    ar & boost::serialization::make_nvp("board", board);
    ar & boost::serialization::make_nvp("boardId", boardId);
    ar & boost::serialization::make_nvp("value", value);
}
COND_SERIALIZATION_INSTANTIATE(cscdqm::TempMeasType);

