
#include "CondFormats/Calibration/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void Algo::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("a", a);
}
COND_SERIALIZATION_INSTANTIATE(Algo);

template <class Archive>
void AlgoMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("std::map-std::string,-Algo-", boost::serialization::base_object<std::map<std::string, Algo>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(AlgoMap);

template <class Archive>
void Algob::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("b", b);
}
COND_SERIALIZATION_INSTANTIATE(Algob);

template <class Archive>
void BlobComplex::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("objects", objects);
}
COND_SERIALIZATION_INSTANTIATE(BlobComplex);

template <class Archive>
void BlobComplexContent::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("data1", data1);
    ar & boost::serialization::make_nvp("data2", data2);
    ar & boost::serialization::make_nvp("data3", data3);
}
COND_SERIALIZATION_INSTANTIATE(BlobComplexContent);

template <class Archive>
void BlobComplexData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("a", a);
    ar & boost::serialization::make_nvp("b", b);
    ar & boost::serialization::make_nvp("values", values);
}
COND_SERIALIZATION_INSTANTIATE(BlobComplexData);

template <class Archive>
void BlobComplexObjects::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("a", a);
    ar & boost::serialization::make_nvp("b", b);
    ar & boost::serialization::make_nvp("content", content);
}
COND_SERIALIZATION_INSTANTIATE(BlobComplexObjects);

template <class Archive>
void BlobNoises::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("v-noises", v_noises);
    ar & boost::serialization::make_nvp("indexes", indexes);
}
COND_SERIALIZATION_INSTANTIATE(BlobNoises);

template <class Archive>
void BlobNoises::DetRegistry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detid", detid);
    ar & boost::serialization::make_nvp("ibegin", ibegin);
    ar & boost::serialization::make_nvp("iend", iend);
}
COND_SERIALIZATION_INSTANTIATE(BlobNoises::DetRegistry);

template <class Archive>
void BlobPedestals::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-pedestals", m_pedestals);
}
COND_SERIALIZATION_INSTANTIATE(BlobPedestals);

template <class Archive>
void CalibHistogram::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-histo", m_histo);
}
COND_SERIALIZATION_INSTANTIATE(CalibHistogram);

template <class Archive>
void CalibHistograms::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-data", m_data);
}
COND_SERIALIZATION_INSTANTIATE(CalibHistograms);

template <class Archive>
void Pedestals::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-pedestals", m_pedestals);
}
COND_SERIALIZATION_INSTANTIATE(Pedestals);

template <class Archive>
void Pedestals::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-mean", m_mean);
    ar & boost::serialization::make_nvp("m-variance", m_variance);
}
COND_SERIALIZATION_INSTANTIATE(Pedestals::Item);

template <class Archive>
void big::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("tVector-", tVector_);
    ar & boost::serialization::make_nvp("thVector-", thVector_);
    ar & boost::serialization::make_nvp("sVector-", sVector_);
    ar & boost::serialization::make_nvp("id-current", id_current);
    ar & boost::serialization::make_nvp("index-id", index_id);
    ar & boost::serialization::make_nvp("cota-current", cota_current);
    ar & boost::serialization::make_nvp("cotb-current", cotb_current);
    ar & boost::serialization::make_nvp("abs-cotb", abs_cotb);
    ar & boost::serialization::make_nvp("fpix-current", fpix_current);
}
COND_SERIALIZATION_INSTANTIATE(big);

template <class Archive>
void big::bigEntry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("runnum", runnum);
    ar & boost::serialization::make_nvp("alpha", alpha);
    ar & boost::serialization::make_nvp("cotalpha", cotalpha);
    ar & boost::serialization::make_nvp("beta", beta);
    ar & boost::serialization::make_nvp("cotbeta", cotbeta);
    ar & boost::serialization::make_nvp("costrk", costrk);
    ar & boost::serialization::make_nvp("qavg", qavg);
    ar & boost::serialization::make_nvp("symax", symax);
    ar & boost::serialization::make_nvp("dyone", dyone);
    ar & boost::serialization::make_nvp("syone", syone);
    ar & boost::serialization::make_nvp("sxmax", sxmax);
    ar & boost::serialization::make_nvp("dxone", dxone);
    ar & boost::serialization::make_nvp("sxone", sxone);
    ar & boost::serialization::make_nvp("dytwo", dytwo);
    ar & boost::serialization::make_nvp("sytwo", sytwo);
    ar & boost::serialization::make_nvp("dxtwo", dxtwo);
    ar & boost::serialization::make_nvp("sxtwo", sxtwo);
    ar & boost::serialization::make_nvp("qmin", qmin);
    ar & boost::serialization::make_nvp("par", par);
    ar & boost::serialization::make_nvp("ytemp", ytemp);
    ar & boost::serialization::make_nvp("xtemp", xtemp);
    ar & boost::serialization::make_nvp("avg", avg);
    ar & boost::serialization::make_nvp("aqfl", aqfl);
    ar & boost::serialization::make_nvp("chi2", chi2);
    ar & boost::serialization::make_nvp("spare", spare);
}
COND_SERIALIZATION_INSTANTIATE(big::bigEntry);

template <class Archive>
void big::bigHeader::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("title", title);
    ar & boost::serialization::make_nvp("ID", ID);
    ar & boost::serialization::make_nvp("NBy", NBy);
    ar & boost::serialization::make_nvp("NByx", NByx);
    ar & boost::serialization::make_nvp("NBxx", NBxx);
    ar & boost::serialization::make_nvp("NFy", NFy);
    ar & boost::serialization::make_nvp("NFyx", NFyx);
    ar & boost::serialization::make_nvp("NFxx", NFxx);
    ar & boost::serialization::make_nvp("vbias", vbias);
    ar & boost::serialization::make_nvp("temperature", temperature);
    ar & boost::serialization::make_nvp("fluence", fluence);
    ar & boost::serialization::make_nvp("qscale", qscale);
    ar & boost::serialization::make_nvp("s50", s50);
    ar & boost::serialization::make_nvp("templ-version", templ_version);
}
COND_SERIALIZATION_INSTANTIATE(big::bigHeader);

template <class Archive>
void big::bigStore::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("head", head);
    ar & boost::serialization::make_nvp("entby", entby);
    ar & boost::serialization::make_nvp("entbx", entbx);
    ar & boost::serialization::make_nvp("entfy", entfy);
    ar & boost::serialization::make_nvp("entfx", entfx);
}
COND_SERIALIZATION_INSTANTIATE(big::bigStore);

template <class Archive>
void boostTypeObj::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("a", a);
    ar & boost::serialization::make_nvp("b", b);
    ar & boost::serialization::make_nvp("aa", aa);
    ar & boost::serialization::make_nvp("bb", bb);
}
COND_SERIALIZATION_INSTANTIATE(boostTypeObj);

template <class Archive>
void child::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mybase", boost::serialization::base_object<mybase>(*this));
    ar & boost::serialization::make_nvp("b", b);
}
COND_SERIALIZATION_INSTANTIATE(child);

template <class Archive>
void condex::ConfF::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cond::BaseKeyed", boost::serialization::base_object<cond::BaseKeyed>(*this));
    ar & boost::serialization::make_nvp("v", v);
    ar & boost::serialization::make_nvp("key", key);
}
COND_SERIALIZATION_INSTANTIATE(condex::ConfF);

template <class Archive>
void condex::ConfI::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cond::BaseKeyed", boost::serialization::base_object<cond::BaseKeyed>(*this));
    ar & boost::serialization::make_nvp("v", v);
    ar & boost::serialization::make_nvp("key", key);
}
COND_SERIALIZATION_INSTANTIATE(condex::ConfI);

template <class Archive>
void condex::Efficiency::serialize(Archive & ar, const unsigned int)
{
}
COND_SERIALIZATION_INSTANTIATE(condex::Efficiency);

template <class Archive>
void condex::ParametricEfficiencyInEta::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("condex::Efficiency", boost::serialization::base_object<condex::Efficiency>(*this));
    ar & boost::serialization::make_nvp("cutLow", cutLow);
    ar & boost::serialization::make_nvp("cutHigh", cutHigh);
    ar & boost::serialization::make_nvp("low", low);
    ar & boost::serialization::make_nvp("high", high);
}
COND_SERIALIZATION_INSTANTIATE(condex::ParametricEfficiencyInEta);

template <class Archive>
void condex::ParametricEfficiencyInPt::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("condex::Efficiency", boost::serialization::base_object<condex::Efficiency>(*this));
    ar & boost::serialization::make_nvp("cutLow", cutLow);
    ar & boost::serialization::make_nvp("cutHigh", cutHigh);
    ar & boost::serialization::make_nvp("low", low);
    ar & boost::serialization::make_nvp("high", high);
}
COND_SERIALIZATION_INSTANTIATE(condex::ParametricEfficiencyInPt);

template <class Archive>
void fakeMenu::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-algorithmMap", m_algorithmMap);
}
COND_SERIALIZATION_INSTANTIATE(fakeMenu);

template <typename T, unsigned int S>
template <class Archive>
void fixedArray<T, S>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("content", content);
}

template <class Archive>
void mySiStripNoises::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("v-noises", v_noises);
    ar & boost::serialization::make_nvp("indexes", indexes);
}
COND_SERIALIZATION_INSTANTIATE(mySiStripNoises);

template <class Archive>
void mySiStripNoises::DetRegistry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detid", detid);
    ar & boost::serialization::make_nvp("ibegin", ibegin);
    ar & boost::serialization::make_nvp("iend", iend);
}
COND_SERIALIZATION_INSTANTIATE(mySiStripNoises::DetRegistry);

template <class Archive>
void mybase::serialize(Archive & ar, const unsigned int)
{
}
COND_SERIALIZATION_INSTANTIATE(mybase);

template <class Archive>
void mypt::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("pt", pt);
}
COND_SERIALIZATION_INSTANTIATE(mypt);

template <class Archive>
void strKeyMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-content", m_content);
}
COND_SERIALIZATION_INSTANTIATE(strKeyMap);

#include "CondFormats/Calibration/src/SerializationManual.h"
