
#include "CondFormats/CastorObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void CastorCalibrationQIECoder::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("bin0", bin0);
    ar & boost::serialization::make_nvp("bin1", bin1);
    ar & boost::serialization::make_nvp("bin2", bin2);
    ar & boost::serialization::make_nvp("bin3", bin3);
    ar & boost::serialization::make_nvp("bin4", bin4);
    ar & boost::serialization::make_nvp("bin5", bin5);
    ar & boost::serialization::make_nvp("bin6", bin6);
    ar & boost::serialization::make_nvp("bin7", bin7);
    ar & boost::serialization::make_nvp("bin8", bin8);
    ar & boost::serialization::make_nvp("bin9", bin9);
    ar & boost::serialization::make_nvp("bin10", bin10);
    ar & boost::serialization::make_nvp("bin11", bin11);
    ar & boost::serialization::make_nvp("bin12", bin12);
    ar & boost::serialization::make_nvp("bin13", bin13);
    ar & boost::serialization::make_nvp("bin14", bin14);
    ar & boost::serialization::make_nvp("bin15", bin15);
    ar & boost::serialization::make_nvp("bin16", bin16);
    ar & boost::serialization::make_nvp("bin17", bin17);
    ar & boost::serialization::make_nvp("bin18", bin18);
    ar & boost::serialization::make_nvp("bin19", bin19);
    ar & boost::serialization::make_nvp("bin20", bin20);
    ar & boost::serialization::make_nvp("bin21", bin21);
    ar & boost::serialization::make_nvp("bin22", bin22);
    ar & boost::serialization::make_nvp("bin23", bin23);
    ar & boost::serialization::make_nvp("bin24", bin24);
    ar & boost::serialization::make_nvp("bin25", bin25);
    ar & boost::serialization::make_nvp("bin26", bin26);
    ar & boost::serialization::make_nvp("bin27", bin27);
    ar & boost::serialization::make_nvp("bin28", bin28);
    ar & boost::serialization::make_nvp("bin29", bin29);
    ar & boost::serialization::make_nvp("bin30", bin30);
    ar & boost::serialization::make_nvp("bin31", bin31);
}
COND_SERIALIZATION_INSTANTIATE(CastorCalibrationQIECoder);

template <class Archive>
void CastorCalibrationQIEData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorCalibrationQIECoder-", boost::serialization::base_object<CastorCondObjectContainer<class CastorCalibrationQIECoder>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(CastorCalibrationQIEData);

template <class Archive>
void CastorChannelQuality::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorChannelStatus-", boost::serialization::base_object<CastorCondObjectContainer<class CastorChannelStatus>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(CastorChannelQuality);

template <class Archive>
void CastorChannelStatus::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mStatus", mStatus);
}
COND_SERIALIZATION_INSTANTIATE(CastorChannelStatus);

template <typename Item>
template <class Archive>
void CastorCondObjectContainer<Item>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CASTORcontainer", CASTORcontainer);
}

template <class Archive>
void CastorElectronicsMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mPItems", mPItems);
    ar & boost::serialization::make_nvp("mTItems", mTItems);
}
COND_SERIALIZATION_INSTANTIATE(CastorElectronicsMap);

template <class Archive>
void CastorElectronicsMap::PrecisionItem::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mElId", mElId);
}
COND_SERIALIZATION_INSTANTIATE(CastorElectronicsMap::PrecisionItem);

template <class Archive>
void CastorElectronicsMap::TriggerItem::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mTrigId", mTrigId);
    ar & boost::serialization::make_nvp("mElId", mElId);
}
COND_SERIALIZATION_INSTANTIATE(CastorElectronicsMap::TriggerItem);

template <class Archive>
void CastorGain::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue0", mValue0);
    ar & boost::serialization::make_nvp("mValue1", mValue1);
    ar & boost::serialization::make_nvp("mValue2", mValue2);
    ar & boost::serialization::make_nvp("mValue3", mValue3);
}
COND_SERIALIZATION_INSTANTIATE(CastorGain);

template <class Archive>
void CastorGainWidth::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue0", mValue0);
    ar & boost::serialization::make_nvp("mValue1", mValue1);
    ar & boost::serialization::make_nvp("mValue2", mValue2);
    ar & boost::serialization::make_nvp("mValue3", mValue3);
}
COND_SERIALIZATION_INSTANTIATE(CastorGainWidth);

template <class Archive>
void CastorGainWidths::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorGainWidth-", boost::serialization::base_object<CastorCondObjectContainer<class CastorGainWidth>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(CastorGainWidths);

template <class Archive>
void CastorGains::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorGain-", boost::serialization::base_object<CastorCondObjectContainer<class CastorGain>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(CastorGains);

template <class Archive>
void CastorPedestal::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue0", mValue0);
    ar & boost::serialization::make_nvp("mValue1", mValue1);
    ar & boost::serialization::make_nvp("mValue2", mValue2);
    ar & boost::serialization::make_nvp("mValue3", mValue3);
    ar & boost::serialization::make_nvp("mWidth0", mWidth0);
    ar & boost::serialization::make_nvp("mWidth1", mWidth1);
    ar & boost::serialization::make_nvp("mWidth2", mWidth2);
    ar & boost::serialization::make_nvp("mWidth3", mWidth3);
}
COND_SERIALIZATION_INSTANTIATE(CastorPedestal);

template <class Archive>
void CastorPedestalWidth::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mSigma00", mSigma00);
    ar & boost::serialization::make_nvp("mSigma01", mSigma01);
    ar & boost::serialization::make_nvp("mSigma02", mSigma02);
    ar & boost::serialization::make_nvp("mSigma03", mSigma03);
    ar & boost::serialization::make_nvp("mSigma10", mSigma10);
    ar & boost::serialization::make_nvp("mSigma11", mSigma11);
    ar & boost::serialization::make_nvp("mSigma12", mSigma12);
    ar & boost::serialization::make_nvp("mSigma13", mSigma13);
    ar & boost::serialization::make_nvp("mSigma20", mSigma20);
    ar & boost::serialization::make_nvp("mSigma21", mSigma21);
    ar & boost::serialization::make_nvp("mSigma22", mSigma22);
    ar & boost::serialization::make_nvp("mSigma23", mSigma23);
    ar & boost::serialization::make_nvp("mSigma30", mSigma30);
    ar & boost::serialization::make_nvp("mSigma31", mSigma31);
    ar & boost::serialization::make_nvp("mSigma32", mSigma32);
    ar & boost::serialization::make_nvp("mSigma33", mSigma33);
}
COND_SERIALIZATION_INSTANTIATE(CastorPedestalWidth);

template <class Archive>
void CastorPedestalWidths::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorPedestalWidth-", boost::serialization::base_object<CastorCondObjectContainer<class CastorPedestalWidth>>(*this));
    ar & boost::serialization::make_nvp("unitIsADC", unitIsADC);
}
COND_SERIALIZATION_INSTANTIATE(CastorPedestalWidths);

template <class Archive>
void CastorPedestals::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorPedestal-", boost::serialization::base_object<CastorCondObjectContainer<class CastorPedestal>>(*this));
    ar & boost::serialization::make_nvp("unitIsADC", unitIsADC);
}
COND_SERIALIZATION_INSTANTIATE(CastorPedestals);

template <class Archive>
void CastorQIECoder::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mOffset00", mOffset00);
    ar & boost::serialization::make_nvp("mOffset01", mOffset01);
    ar & boost::serialization::make_nvp("mOffset02", mOffset02);
    ar & boost::serialization::make_nvp("mOffset03", mOffset03);
    ar & boost::serialization::make_nvp("mOffset10", mOffset10);
    ar & boost::serialization::make_nvp("mOffset11", mOffset11);
    ar & boost::serialization::make_nvp("mOffset12", mOffset12);
    ar & boost::serialization::make_nvp("mOffset13", mOffset13);
    ar & boost::serialization::make_nvp("mOffset20", mOffset20);
    ar & boost::serialization::make_nvp("mOffset21", mOffset21);
    ar & boost::serialization::make_nvp("mOffset22", mOffset22);
    ar & boost::serialization::make_nvp("mOffset23", mOffset23);
    ar & boost::serialization::make_nvp("mOffset30", mOffset30);
    ar & boost::serialization::make_nvp("mOffset31", mOffset31);
    ar & boost::serialization::make_nvp("mOffset32", mOffset32);
    ar & boost::serialization::make_nvp("mOffset33", mOffset33);
    ar & boost::serialization::make_nvp("mSlope00", mSlope00);
    ar & boost::serialization::make_nvp("mSlope01", mSlope01);
    ar & boost::serialization::make_nvp("mSlope02", mSlope02);
    ar & boost::serialization::make_nvp("mSlope03", mSlope03);
    ar & boost::serialization::make_nvp("mSlope10", mSlope10);
    ar & boost::serialization::make_nvp("mSlope11", mSlope11);
    ar & boost::serialization::make_nvp("mSlope12", mSlope12);
    ar & boost::serialization::make_nvp("mSlope13", mSlope13);
    ar & boost::serialization::make_nvp("mSlope20", mSlope20);
    ar & boost::serialization::make_nvp("mSlope21", mSlope21);
    ar & boost::serialization::make_nvp("mSlope22", mSlope22);
    ar & boost::serialization::make_nvp("mSlope23", mSlope23);
    ar & boost::serialization::make_nvp("mSlope30", mSlope30);
    ar & boost::serialization::make_nvp("mSlope31", mSlope31);
    ar & boost::serialization::make_nvp("mSlope32", mSlope32);
    ar & boost::serialization::make_nvp("mSlope33", mSlope33);
}
COND_SERIALIZATION_INSTANTIATE(CastorQIECoder);

template <class Archive>
void CastorQIEData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorQIECoder-", boost::serialization::base_object<CastorCondObjectContainer<class CastorQIECoder>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(CastorQIEData);

template <class Archive>
void CastorRecoParam::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mFirstSample", mFirstSample);
    ar & boost::serialization::make_nvp("mSamplesToAdd", mSamplesToAdd);
}
COND_SERIALIZATION_INSTANTIATE(CastorRecoParam);

template <class Archive>
void CastorRecoParams::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorRecoParam-", boost::serialization::base_object<CastorCondObjectContainer<class CastorRecoParam>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(CastorRecoParams);

template <class Archive>
void CastorSaturationCorr::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mSatCorr", mSatCorr);
}
COND_SERIALIZATION_INSTANTIATE(CastorSaturationCorr);

template <class Archive>
void CastorSaturationCorrs::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("CastorCondObjectContainer-class-CastorSaturationCorr-", boost::serialization::base_object<CastorCondObjectContainer<class CastorSaturationCorr>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(CastorSaturationCorrs);

