
#include "CondFormats/DQMObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void DQMSummary::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-run", m_run);
    ar & boost::serialization::make_nvp("m-summary", m_summary);
}
COND_SERIALIZATION_INSTANTIATE(DQMSummary);

template <class Archive>
void DQMSummary::RunItem::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-lumisec", m_lumisec);
    ar & boost::serialization::make_nvp("m-lumisummary", m_lumisummary);
}
COND_SERIALIZATION_INSTANTIATE(DQMSummary::RunItem);

template <class Archive>
void DQMSummary::RunItem::LumiItem::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-subsystem", m_subsystem);
    ar & boost::serialization::make_nvp("m-reportcontent", m_reportcontent);
    ar & boost::serialization::make_nvp("m-type", m_type);
    ar & boost::serialization::make_nvp("m-status", m_status);
}
COND_SERIALIZATION_INSTANTIATE(DQMSummary::RunItem::LumiItem);

template <class Archive>
void HDQMSummary::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("userDBContent-", userDBContent_);
    ar & boost::serialization::make_nvp("v-sum-", v_sum_);
    ar & boost::serialization::make_nvp("indexes-", indexes_);
    ar & boost::serialization::make_nvp("runNr-", runNr_);
    ar & boost::serialization::make_nvp("timeValue-", timeValue_);
}
COND_SERIALIZATION_INSTANTIATE(HDQMSummary);

template <class Archive>
void HDQMSummary::DetRegistry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detid", detid);
    ar & boost::serialization::make_nvp("ibegin", ibegin);
}
COND_SERIALIZATION_INSTANTIATE(HDQMSummary::DetRegistry);

