
#include "CondFormats/DTObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void DTCCBConfig::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("timeStamp", timeStamp);
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("fullConfigKey", fullConfigKey);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTCCBConfig);

template <class Archive>
void DTCCBId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
}
COND_SERIALIZATION_INSTANTIATE(DTCCBId);

template <class Archive>
void DTConfigKey::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("confType", confType);
    ar & boost::serialization::make_nvp("confKey", confKey);
}
COND_SERIALIZATION_INSTANTIATE(DTConfigKey);

template <class Archive>
void DTDeadFlag::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTDeadFlag);

template <class Archive>
void DTDeadFlagData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dead-HV", dead_HV);
    ar & boost::serialization::make_nvp("dead-TP", dead_TP);
    ar & boost::serialization::make_nvp("dead-RO", dead_RO);
    ar & boost::serialization::make_nvp("discCat", discCat);
}
COND_SERIALIZATION_INSTANTIATE(DTDeadFlagData);

template <class Archive>
void DTDeadFlagId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
    ar & boost::serialization::make_nvp("slId", slId);
    ar & boost::serialization::make_nvp("layerId", layerId);
    ar & boost::serialization::make_nvp("cellId", cellId);
}
COND_SERIALIZATION_INSTANTIATE(DTDeadFlagId);

template <class Archive>
void DTHVStatus::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTHVStatus);

template <class Archive>
void DTHVStatusData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fCell", fCell);
    ar & boost::serialization::make_nvp("lCell", lCell);
    ar & boost::serialization::make_nvp("flagA", flagA);
    ar & boost::serialization::make_nvp("flagC", flagC);
    ar & boost::serialization::make_nvp("flagS", flagS);
}
COND_SERIALIZATION_INSTANTIATE(DTHVStatusData);

template <class Archive>
void DTHVStatusId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
    ar & boost::serialization::make_nvp("slId", slId);
    ar & boost::serialization::make_nvp("layerId", layerId);
    ar & boost::serialization::make_nvp("partId", partId);
}
COND_SERIALIZATION_INSTANTIATE(DTHVStatusId);

template <class Archive>
void DTKeyedConfig::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cond::BaseKeyed", boost::serialization::base_object<cond::BaseKeyed>(*this));
    ar & boost::serialization::make_nvp("cfgId", cfgId);
    ar & boost::serialization::make_nvp("dataList", dataList);
    ar & boost::serialization::make_nvp("linkList", linkList);
}
COND_SERIALIZATION_INSTANTIATE(DTKeyedConfig);

template <class Archive>
void DTLVStatus::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTLVStatus);

template <class Archive>
void DTLVStatusData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("flagCFE", flagCFE);
    ar & boost::serialization::make_nvp("flagDFE", flagDFE);
    ar & boost::serialization::make_nvp("flagCMC", flagCMC);
    ar & boost::serialization::make_nvp("flagDMC", flagDMC);
}
COND_SERIALIZATION_INSTANTIATE(DTLVStatusData);

template <class Archive>
void DTLVStatusId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
}
COND_SERIALIZATION_INSTANTIATE(DTLVStatusId);

template <class Archive>
void DTMtime::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("nsPerCount", nsPerCount);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTMtime);

template <class Archive>
void DTMtimeData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mTime", mTime);
    ar & boost::serialization::make_nvp("mTrms", mTrms);
}
COND_SERIALIZATION_INSTANTIATE(DTMtimeData);

template <class Archive>
void DTMtimeId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
    ar & boost::serialization::make_nvp("slId", slId);
    ar & boost::serialization::make_nvp("layerId", layerId);
    ar & boost::serialization::make_nvp("cellId", cellId);
}
COND_SERIALIZATION_INSTANTIATE(DTMtimeId);

template <class Archive>
void DTPerformance::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("nsPerCount", nsPerCount);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTPerformance);

template <class Archive>
void DTPerformanceData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("meanT0", meanT0);
    ar & boost::serialization::make_nvp("meanTtrig", meanTtrig);
    ar & boost::serialization::make_nvp("meanMtime", meanMtime);
    ar & boost::serialization::make_nvp("meanNoise", meanNoise);
    ar & boost::serialization::make_nvp("meanAfterPulse", meanAfterPulse);
    ar & boost::serialization::make_nvp("meanResolution", meanResolution);
    ar & boost::serialization::make_nvp("meanEfficiency", meanEfficiency);
}
COND_SERIALIZATION_INSTANTIATE(DTPerformanceData);

template <class Archive>
void DTPerformanceId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
    ar & boost::serialization::make_nvp("slId", slId);
}
COND_SERIALIZATION_INSTANTIATE(DTPerformanceId);

template <class Archive>
void DTRangeT0::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTRangeT0);

template <class Archive>
void DTRangeT0Data::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("t0min", t0min);
    ar & boost::serialization::make_nvp("t0max", t0max);
}
COND_SERIALIZATION_INSTANTIATE(DTRangeT0Data);

template <class Archive>
void DTRangeT0Id::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
    ar & boost::serialization::make_nvp("slId", slId);
}
COND_SERIALIZATION_INSTANTIATE(DTRangeT0Id);

template <class Archive>
void DTReadOutGeometryLink::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dduId", dduId);
    ar & boost::serialization::make_nvp("rosId", rosId);
    ar & boost::serialization::make_nvp("robId", robId);
    ar & boost::serialization::make_nvp("tdcId", tdcId);
    ar & boost::serialization::make_nvp("channelId", channelId);
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
    ar & boost::serialization::make_nvp("slId", slId);
    ar & boost::serialization::make_nvp("layerId", layerId);
    ar & boost::serialization::make_nvp("cellId", cellId);
}
COND_SERIALIZATION_INSTANTIATE(DTReadOutGeometryLink);

template <class Archive>
void DTReadOutMapping::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cellMapVersion", cellMapVersion);
    ar & boost::serialization::make_nvp("robMapVersion", robMapVersion);
    ar & boost::serialization::make_nvp("readOutChannelDriftTubeMap", readOutChannelDriftTubeMap);
}
COND_SERIALIZATION_INSTANTIATE(DTReadOutMapping);

template <class Archive>
void DTRecoConditions::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("expression", expression);
    ar & boost::serialization::make_nvp("payload", payload);
    ar & boost::serialization::make_nvp("theVersion", theVersion);
}
COND_SERIALIZATION_INSTANTIATE(DTRecoConditions);

template <class Archive>
void DTRecoUncertainties::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("payload", payload);
    ar & boost::serialization::make_nvp("theVersion", theVersion);
}
COND_SERIALIZATION_INSTANTIATE(DTRecoUncertainties);

template <class Archive>
void DTStatusFlag::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTStatusFlag);

template <class Archive>
void DTStatusFlagData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("noiseFlag", noiseFlag);
    ar & boost::serialization::make_nvp("feMask", feMask);
    ar & boost::serialization::make_nvp("tdcMask", tdcMask);
    ar & boost::serialization::make_nvp("trigMask", trigMask);
    ar & boost::serialization::make_nvp("deadFlag", deadFlag);
    ar & boost::serialization::make_nvp("nohvFlag", nohvFlag);
}
COND_SERIALIZATION_INSTANTIATE(DTStatusFlagData);

template <class Archive>
void DTStatusFlagId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
    ar & boost::serialization::make_nvp("slId", slId);
    ar & boost::serialization::make_nvp("layerId", layerId);
    ar & boost::serialization::make_nvp("cellId", cellId);
}
COND_SERIALIZATION_INSTANTIATE(DTStatusFlagId);

template <class Archive>
void DTT0::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("nsPerCount", nsPerCount);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTT0);

template <class Archive>
void DTT0Data::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("channelId", channelId);
    ar & boost::serialization::make_nvp("t0mean", t0mean);
    ar & boost::serialization::make_nvp("t0rms", t0rms);
}
COND_SERIALIZATION_INSTANTIATE(DTT0Data);

template <class Archive>
void DTTPGParameters::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("nsPerCount", nsPerCount);
    ar & boost::serialization::make_nvp("clockLength", clockLength);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTTPGParameters);

template <class Archive>
void DTTPGParametersData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("nClock", nClock);
    ar & boost::serialization::make_nvp("tPhase", tPhase);
}
COND_SERIALIZATION_INSTANTIATE(DTTPGParametersData);

template <class Archive>
void DTTPGParametersId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
}
COND_SERIALIZATION_INSTANTIATE(DTTPGParametersId);

template <class Archive>
void DTTtrig::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("dataVersion", dataVersion);
    ar & boost::serialization::make_nvp("nsPerCount", nsPerCount);
    ar & boost::serialization::make_nvp("dataList", dataList);
}
COND_SERIALIZATION_INSTANTIATE(DTTtrig);

template <class Archive>
void DTTtrigData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("tTrig", tTrig);
    ar & boost::serialization::make_nvp("tTrms", tTrms);
    ar & boost::serialization::make_nvp("kFact", kFact);
}
COND_SERIALIZATION_INSTANTIATE(DTTtrigData);

template <class Archive>
void DTTtrigId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wheelId", wheelId);
    ar & boost::serialization::make_nvp("stationId", stationId);
    ar & boost::serialization::make_nvp("sectorId", sectorId);
    ar & boost::serialization::make_nvp("slId", slId);
    ar & boost::serialization::make_nvp("layerId", layerId);
    ar & boost::serialization::make_nvp("cellId", cellId);
}
COND_SERIALIZATION_INSTANTIATE(DTTtrigId);

