
#include "CondFormats/ESObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void ESADCToGeVConstant::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ESvaluelow-", ESvaluelow_);
    ar & boost::serialization::make_nvp("ESvaluehigh-", ESvaluehigh_);
}
COND_SERIALIZATION_INSTANTIATE(ESADCToGeVConstant);

template <class Archive>
void ESChannelStatusCode::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("status-", status_);
}
COND_SERIALIZATION_INSTANTIATE(ESChannelStatusCode);

template <typename T>
template <class Archive>
void ESCondObjectContainer<T>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("es-", es_);
}

template <class Archive>
void ESEEIntercalibConstants::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("gammaLow0-", gammaLow0_);
    ar & boost::serialization::make_nvp("alphaLow0-", alphaLow0_);
    ar & boost::serialization::make_nvp("gammaHigh0-", gammaHigh0_);
    ar & boost::serialization::make_nvp("alphaHigh0-", alphaHigh0_);
    ar & boost::serialization::make_nvp("gammaLow1-", gammaLow1_);
    ar & boost::serialization::make_nvp("alphaLow1-", alphaLow1_);
    ar & boost::serialization::make_nvp("gammaHigh1-", gammaHigh1_);
    ar & boost::serialization::make_nvp("alphaHigh1-", alphaHigh1_);
    ar & boost::serialization::make_nvp("gammaLow2-", gammaLow2_);
    ar & boost::serialization::make_nvp("alphaLow2-", alphaLow2_);
    ar & boost::serialization::make_nvp("gammaHigh2-", gammaHigh2_);
    ar & boost::serialization::make_nvp("alphaHigh2-", alphaHigh2_);
    ar & boost::serialization::make_nvp("gammaLow3-", gammaLow3_);
    ar & boost::serialization::make_nvp("alphaLow3-", alphaLow3_);
    ar & boost::serialization::make_nvp("gammaHigh3-", gammaHigh3_);
    ar & boost::serialization::make_nvp("alphaHigh3-", alphaHigh3_);
}
COND_SERIALIZATION_INSTANTIATE(ESEEIntercalibConstants);

template <class Archive>
void ESGain::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("gain-", gain_);
}
COND_SERIALIZATION_INSTANTIATE(ESGain);

template <class Archive>
void ESMIPToGeVConstant::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ESvaluelow-", ESvaluelow_);
    ar & boost::serialization::make_nvp("ESvaluehigh-", ESvaluehigh_);
}
COND_SERIALIZATION_INSTANTIATE(ESMIPToGeVConstant);

template <class Archive>
void ESMissingEnergyCalibration::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ConstAEta0-", ConstAEta0_);
    ar & boost::serialization::make_nvp("ConstBEta0-", ConstBEta0_);
    ar & boost::serialization::make_nvp("ConstAEta1-", ConstAEta1_);
    ar & boost::serialization::make_nvp("ConstBEta1-", ConstBEta1_);
    ar & boost::serialization::make_nvp("ConstAEta2-", ConstAEta2_);
    ar & boost::serialization::make_nvp("ConstBEta2-", ConstBEta2_);
    ar & boost::serialization::make_nvp("ConstAEta3-", ConstAEta3_);
    ar & boost::serialization::make_nvp("ConstBEta3-", ConstBEta3_);
}
COND_SERIALIZATION_INSTANTIATE(ESMissingEnergyCalibration);

template <class Archive>
void ESPedestal::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mean", mean);
    ar & boost::serialization::make_nvp("rms", rms);
}
COND_SERIALIZATION_INSTANTIATE(ESPedestal);

template <class Archive>
void ESRecHitRatioCuts::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("r12Low-", r12Low_);
    ar & boost::serialization::make_nvp("r23Low-", r23Low_);
    ar & boost::serialization::make_nvp("r12High-", r12High_);
    ar & boost::serialization::make_nvp("r23High-", r23High_);
}
COND_SERIALIZATION_INSTANTIATE(ESRecHitRatioCuts);

template <class Archive>
void ESStripGroupId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("id-", id_);
}
COND_SERIALIZATION_INSTANTIATE(ESStripGroupId);

template <class Archive>
void ESTBWeights::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(ESTBWeights);

template <class Archive>
void ESThresholds::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ts2-", ts2_);
    ar & boost::serialization::make_nvp("zs-", zs_);
}
COND_SERIALIZATION_INSTANTIATE(ESThresholds);

template <class Archive>
void ESTimeSampleWeights::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("w0-", w0_);
    ar & boost::serialization::make_nvp("w1-", w1_);
    ar & boost::serialization::make_nvp("w2-", w2_);
}
COND_SERIALIZATION_INSTANTIATE(ESTimeSampleWeights);

template <class Archive>
void ESWeightSet::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wgtBeforeSwitch-", wgtBeforeSwitch_);
}
COND_SERIALIZATION_INSTANTIATE(ESWeightSet);

#include "CondFormats/ESObjects/src/SerializationManual.h"
