
#include "CondFormats/EcalObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void EcalADCToGeVConstant::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("EBvalue-", EBvalue_);
    ar & boost::serialization::make_nvp("EEvalue-", EEvalue_);
}
COND_SERIALIZATION_INSTANTIATE(EcalADCToGeVConstant);

template <class Archive>
void EcalChannelStatusCode::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("status-", status_);
}
COND_SERIALIZATION_INSTANTIATE(EcalChannelStatusCode);

template <typename T>
template <class Archive>
void EcalCondObjectContainer<T>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("eb-", eb_);
    ar & boost::serialization::make_nvp("ee-", ee_);
}

template <typename T>
template <class Archive>
void EcalCondTowerObjectContainer<T>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("eb-", eb_);
    ar & boost::serialization::make_nvp("ee-", ee_);
}

template <class Archive>
void EcalDAQStatusCode::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("status-", status_);
}
COND_SERIALIZATION_INSTANTIATE(EcalDAQStatusCode);

template <class Archive>
void EcalDCUTemperatures::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalDCUTemperatures);

template <class Archive>
void EcalDQMStatusCode::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("status-", status_);
}
COND_SERIALIZATION_INSTANTIATE(EcalDQMStatusCode);

template <class Archive>
void EcalFunParams::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-params", m_params);
}
COND_SERIALIZATION_INSTANTIATE(EcalFunParams);

template <class Archive>
void EcalLaserAPDPNRatios::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("laser-map", laser_map);
    ar & boost::serialization::make_nvp("time-map", time_map);
}
COND_SERIALIZATION_INSTANTIATE(EcalLaserAPDPNRatios);

template <class Archive>
void EcalLaserAPDPNRatios::EcalLaserAPDPNpair::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("p1", p1);
    ar & boost::serialization::make_nvp("p2", p2);
    ar & boost::serialization::make_nvp("p3", p3);
}
COND_SERIALIZATION_INSTANTIATE(EcalLaserAPDPNRatios::EcalLaserAPDPNpair);

template <class Archive>
void EcalLaserAPDPNRatios::EcalLaserTimeStamp::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("t1", t1);
    ar & boost::serialization::make_nvp("t2", t2);
    ar & boost::serialization::make_nvp("t3", t3);
}
COND_SERIALIZATION_INSTANTIATE(EcalLaserAPDPNRatios::EcalLaserTimeStamp);

template <class Archive>
void EcalMGPAGainRatio::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("gain12Over6-", gain12Over6_);
    ar & boost::serialization::make_nvp("gain6Over1-", gain6Over1_);
}
COND_SERIALIZATION_INSTANTIATE(EcalMGPAGainRatio);

template <class Archive>
void EcalMappingElement::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("electronicsid", electronicsid);
    ar & boost::serialization::make_nvp("triggerid", triggerid);
}
COND_SERIALIZATION_INSTANTIATE(EcalMappingElement);

template <class Archive>
void EcalPTMTemperatures::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalPTMTemperatures);

template <class Archive>
void EcalPedestal::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mean-x12", mean_x12);
    ar & boost::serialization::make_nvp("rms-x12", rms_x12);
    ar & boost::serialization::make_nvp("mean-x6", mean_x6);
    ar & boost::serialization::make_nvp("rms-x6", rms_x6);
    ar & boost::serialization::make_nvp("mean-x1", mean_x1);
    ar & boost::serialization::make_nvp("rms-x1", rms_x1);
}
COND_SERIALIZATION_INSTANTIATE(EcalPedestal);

template <class Archive>
void EcalPulseCovariance::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("covval", covval);
}
COND_SERIALIZATION_INSTANTIATE(EcalPulseCovariance);

template <class Archive>
void EcalPulseShape::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("pdfval", pdfval);
}
COND_SERIALIZATION_INSTANTIATE(EcalPulseShape);

template <class Archive>
void EcalSRSettings::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("deltaEta-", deltaEta_);
    ar & boost::serialization::make_nvp("deltaPhi-", deltaPhi_);
    ar & boost::serialization::make_nvp("ecalDccZs1stSample-", ecalDccZs1stSample_);
    ar & boost::serialization::make_nvp("ebDccAdcToGeV-", ebDccAdcToGeV_);
    ar & boost::serialization::make_nvp("eeDccAdcToGeV-", eeDccAdcToGeV_);
    ar & boost::serialization::make_nvp("dccNormalizedWeights-", dccNormalizedWeights_);
    ar & boost::serialization::make_nvp("symetricZS-", symetricZS_);
    ar & boost::serialization::make_nvp("srpLowInterestChannelZS-", srpLowInterestChannelZS_);
    ar & boost::serialization::make_nvp("srpHighInterestChannelZS-", srpHighInterestChannelZS_);
    ar & boost::serialization::make_nvp("actions-", actions_);
    ar & boost::serialization::make_nvp("tccMasksFromConfig-", tccMasksFromConfig_);
    ar & boost::serialization::make_nvp("srpMasksFromConfig-", srpMasksFromConfig_);
    ar & boost::serialization::make_nvp("dccMasks-", dccMasks_);
    ar & boost::serialization::make_nvp("srfMasks-", srfMasks_);
    ar & boost::serialization::make_nvp("substitutionSrfs-", substitutionSrfs_);
    ar & boost::serialization::make_nvp("testerTccEmuSrpIds-", testerTccEmuSrpIds_);
    ar & boost::serialization::make_nvp("testerSrpEmuSrpIds-", testerSrpEmuSrpIds_);
    ar & boost::serialization::make_nvp("testerDccTestSrpIds-", testerDccTestSrpIds_);
    ar & boost::serialization::make_nvp("testerSrpTestSrpIds-", testerSrpTestSrpIds_);
    ar & boost::serialization::make_nvp("bxOffsets-", bxOffsets_);
    ar & boost::serialization::make_nvp("bxGlobalOffset-", bxGlobalOffset_);
    ar & boost::serialization::make_nvp("automaticMasks-", automaticMasks_);
    ar & boost::serialization::make_nvp("automaticSrpSelect-", automaticSrpSelect_);
}
COND_SERIALIZATION_INSTANTIATE(EcalSRSettings);

template <class Archive>
void EcalSampleMask::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("sampleMaskEB-", sampleMaskEB_);
    ar & boost::serialization::make_nvp("sampleMaskEE-", sampleMaskEE_);
}
COND_SERIALIZATION_INSTANTIATE(EcalSampleMask);

template <class Archive>
void EcalSamplesCorrelation::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("EBG12SamplesCorrelation", EBG12SamplesCorrelation);
    ar & boost::serialization::make_nvp("EBG6SamplesCorrelation", EBG6SamplesCorrelation);
    ar & boost::serialization::make_nvp("EBG1SamplesCorrelation", EBG1SamplesCorrelation);
    ar & boost::serialization::make_nvp("EEG12SamplesCorrelation", EEG12SamplesCorrelation);
    ar & boost::serialization::make_nvp("EEG6SamplesCorrelation", EEG6SamplesCorrelation);
    ar & boost::serialization::make_nvp("EEG1SamplesCorrelation", EEG1SamplesCorrelation);
}
COND_SERIALIZATION_INSTANTIATE(EcalSamplesCorrelation);

template <class Archive>
void EcalTBWeights::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTBWeights);

template <class Archive>
void EcalTPGCrystalStatusCode::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("status-", status_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGCrystalStatusCode);

template <class Archive>
void EcalTPGFineGrainConstEB::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ThresholdETLow-", ThresholdETLow_);
    ar & boost::serialization::make_nvp("ThresholdETHigh-", ThresholdETHigh_);
    ar & boost::serialization::make_nvp("RatioLow-", RatioLow_);
    ar & boost::serialization::make_nvp("RatioHigh-", RatioHigh_);
    ar & boost::serialization::make_nvp("LUT-", LUT_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGFineGrainConstEB);

template <class Archive>
void EcalTPGFineGrainEBGroup::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("EcalTPGGroups", boost::serialization::base_object<EcalTPGGroups>(*this));
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGFineGrainEBGroup);

template <class Archive>
void EcalTPGFineGrainEBIdMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGFineGrainEBIdMap);

template <class Archive>
void EcalTPGFineGrainStripEE::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGFineGrainStripEE);

template <class Archive>
void EcalTPGFineGrainStripEE::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("threshold", threshold);
    ar & boost::serialization::make_nvp("lut", lut);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGFineGrainStripEE::Item);

template <class Archive>
void EcalTPGFineGrainTowerEE::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGFineGrainTowerEE);

template <class Archive>
void EcalTPGGroups::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGGroups);

template <class Archive>
void EcalTPGLinearizationConstant::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mult-x12", mult_x12);
    ar & boost::serialization::make_nvp("mult-x6", mult_x6);
    ar & boost::serialization::make_nvp("mult-x1", mult_x1);
    ar & boost::serialization::make_nvp("shift-x12", shift_x12);
    ar & boost::serialization::make_nvp("shift-x6", shift_x6);
    ar & boost::serialization::make_nvp("shift-x1", shift_x1);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGLinearizationConstant);

template <class Archive>
void EcalTPGLut::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("lut-", lut_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGLut);

template <class Archive>
void EcalTPGLutGroup::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("EcalTPGGroups", boost::serialization::base_object<EcalTPGGroups>(*this));
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGLutGroup);

template <class Archive>
void EcalTPGLutIdMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGLutIdMap);

template <class Archive>
void EcalTPGPedestal::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mean-x12", mean_x12);
    ar & boost::serialization::make_nvp("mean-x6", mean_x6);
    ar & boost::serialization::make_nvp("mean-x1", mean_x1);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGPedestal);

template <class Archive>
void EcalTPGPhysicsConst::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGPhysicsConst);

template <class Archive>
void EcalTPGPhysicsConst::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("EtSat", EtSat);
    ar & boost::serialization::make_nvp("ttf-threshold-Low", ttf_threshold_Low);
    ar & boost::serialization::make_nvp("ttf-threshold-High", ttf_threshold_High);
    ar & boost::serialization::make_nvp("FG-lowThreshold", FG_lowThreshold);
    ar & boost::serialization::make_nvp("FG-highThreshold", FG_highThreshold);
    ar & boost::serialization::make_nvp("FG-lowRatio", FG_lowRatio);
    ar & boost::serialization::make_nvp("FG-highRatio", FG_highRatio);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGPhysicsConst::Item);

template <class Archive>
void EcalTPGSlidingWindow::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGSlidingWindow);

template <class Archive>
void EcalTPGSpike::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGSpike);

template <class Archive>
void EcalTPGStripStatus::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGStripStatus);

template <class Archive>
void EcalTPGTowerStatus::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGTowerStatus);

template <class Archive>
void EcalTPGWeightGroup::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("EcalTPGGroups", boost::serialization::base_object<EcalTPGGroups>(*this));
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGWeightGroup);

template <class Archive>
void EcalTPGWeightIdMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("map-", map_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGWeightIdMap);

template <class Archive>
void EcalTPGWeights::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("w0-", w0_);
    ar & boost::serialization::make_nvp("w1-", w1_);
    ar & boost::serialization::make_nvp("w2-", w2_);
    ar & boost::serialization::make_nvp("w3-", w3_);
    ar & boost::serialization::make_nvp("w4-", w4_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTPGWeights);

template <class Archive>
void EcalTimeBiasCorrections::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("EBTimeCorrAmplitudeBins", EBTimeCorrAmplitudeBins);
    ar & boost::serialization::make_nvp("EBTimeCorrShiftBins", EBTimeCorrShiftBins);
    ar & boost::serialization::make_nvp("EETimeCorrAmplitudeBins", EETimeCorrAmplitudeBins);
    ar & boost::serialization::make_nvp("EETimeCorrShiftBins", EETimeCorrShiftBins);
}
COND_SERIALIZATION_INSTANTIATE(EcalTimeBiasCorrections);

template <class Archive>
void EcalTimeDependentCorrections::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("value-map", value_map);
    ar & boost::serialization::make_nvp("time-map", time_map);
}
COND_SERIALIZATION_INSTANTIATE(EcalTimeDependentCorrections);

template <class Archive>
void EcalTimeDependentCorrections::Times::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("t1", t1);
    ar & boost::serialization::make_nvp("t2", t2);
    ar & boost::serialization::make_nvp("t3", t3);
}
COND_SERIALIZATION_INSTANTIATE(EcalTimeDependentCorrections::Times);

template <class Archive>
void EcalTimeDependentCorrections::Values::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("p1", p1);
    ar & boost::serialization::make_nvp("p2", p2);
    ar & boost::serialization::make_nvp("p3", p3);
}
COND_SERIALIZATION_INSTANTIATE(EcalTimeDependentCorrections::Values);

template <class Archive>
void EcalTimeOffsetConstant::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("EBvalue-", EBvalue_);
    ar & boost::serialization::make_nvp("EEvalue-", EEvalue_);
}
COND_SERIALIZATION_INSTANTIATE(EcalTimeOffsetConstant);

template <class Archive>
void EcalWeightSet::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("wgtBeforeSwitch-", wgtBeforeSwitch_);
    ar & boost::serialization::make_nvp("wgtAfterSwitch-", wgtAfterSwitch_);
    ar & boost::serialization::make_nvp("wgtChi2BeforeSwitch-", wgtChi2BeforeSwitch_);
    ar & boost::serialization::make_nvp("wgtChi2AfterSwitch-", wgtChi2AfterSwitch_);
}
COND_SERIALIZATION_INSTANTIATE(EcalWeightSet);

template <class Archive>
void EcalXtalGroupId::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("id-", id_);
}
COND_SERIALIZATION_INSTANTIATE(EcalXtalGroupId);

#include "CondFormats/EcalObjects/src/SerializationManual.h"
