
#include "CondFormats/EgammaObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void ElectronLikelihoodCalibration::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("data", data);
}
COND_SERIALIZATION_INSTANTIATE(ElectronLikelihoodCalibration);

template <class Archive>
void ElectronLikelihoodCalibration::Entry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("category", category);
    ar & boost::serialization::make_nvp("histogram", histogram);
}
COND_SERIALIZATION_INSTANTIATE(ElectronLikelihoodCalibration::Entry);

template <class Archive>
void ElectronLikelihoodCategoryData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("ecaldet", ecaldet);
    ar & boost::serialization::make_nvp("ptbin", ptbin);
    ar & boost::serialization::make_nvp("iclass", iclass);
    ar & boost::serialization::make_nvp("ifullclass", ifullclass);
    ar & boost::serialization::make_nvp("label", label);
}
COND_SERIALIZATION_INSTANTIATE(ElectronLikelihoodCategoryData);

template <class Archive>
void GBRForest::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fInitialResponse", fInitialResponse);
    ar & boost::serialization::make_nvp("fTrees", fTrees);
}
COND_SERIALIZATION_INSTANTIATE(GBRForest);

template <class Archive>
void GBRForest2D::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fInitialResponseX", fInitialResponseX);
    ar & boost::serialization::make_nvp("fInitialResponseY", fInitialResponseY);
    ar & boost::serialization::make_nvp("fTrees", fTrees);
}
COND_SERIALIZATION_INSTANTIATE(GBRForest2D);

template <class Archive>
void GBRForestD::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fInitialResponse", fInitialResponse);
    ar & boost::serialization::make_nvp("fTrees", fTrees);
}
COND_SERIALIZATION_INSTANTIATE(GBRForestD);

template <class Archive>
void GBRTree::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fCutIndices", fCutIndices);
    ar & boost::serialization::make_nvp("fCutVals", fCutVals);
    ar & boost::serialization::make_nvp("fLeftIndices", fLeftIndices);
    ar & boost::serialization::make_nvp("fRightIndices", fRightIndices);
    ar & boost::serialization::make_nvp("fResponses", fResponses);
}
COND_SERIALIZATION_INSTANTIATE(GBRTree);

template <class Archive>
void GBRTree2D::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fCutIndices", fCutIndices);
    ar & boost::serialization::make_nvp("fCutVals", fCutVals);
    ar & boost::serialization::make_nvp("fLeftIndices", fLeftIndices);
    ar & boost::serialization::make_nvp("fRightIndices", fRightIndices);
    ar & boost::serialization::make_nvp("fResponsesX", fResponsesX);
    ar & boost::serialization::make_nvp("fResponsesY", fResponsesY);
}
COND_SERIALIZATION_INSTANTIATE(GBRTree2D);

template <class Archive>
void GBRTreeD::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fCutIndices", fCutIndices);
    ar & boost::serialization::make_nvp("fCutVals", fCutVals);
    ar & boost::serialization::make_nvp("fLeftIndices", fLeftIndices);
    ar & boost::serialization::make_nvp("fRightIndices", fRightIndices);
    ar & boost::serialization::make_nvp("fResponses", fResponses);
}
COND_SERIALIZATION_INSTANTIATE(GBRTreeD);

