
#include "CondFormats/HcalObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void HcalCalibrationQIECoder::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("bin0", bin0);
    ar & boost::serialization::make_nvp("bin1", bin1);
    ar & boost::serialization::make_nvp("bin2", bin2);
    ar & boost::serialization::make_nvp("bin3", bin3);
    ar & boost::serialization::make_nvp("bin4", bin4);
    ar & boost::serialization::make_nvp("bin5", bin5);
    ar & boost::serialization::make_nvp("bin6", bin6);
    ar & boost::serialization::make_nvp("bin7", bin7);
    ar & boost::serialization::make_nvp("bin8", bin8);
    ar & boost::serialization::make_nvp("bin9", bin9);
    ar & boost::serialization::make_nvp("bin10", bin10);
    ar & boost::serialization::make_nvp("bin11", bin11);
    ar & boost::serialization::make_nvp("bin12", bin12);
    ar & boost::serialization::make_nvp("bin13", bin13);
    ar & boost::serialization::make_nvp("bin14", bin14);
    ar & boost::serialization::make_nvp("bin15", bin15);
    ar & boost::serialization::make_nvp("bin16", bin16);
    ar & boost::serialization::make_nvp("bin17", bin17);
    ar & boost::serialization::make_nvp("bin18", bin18);
    ar & boost::serialization::make_nvp("bin19", bin19);
    ar & boost::serialization::make_nvp("bin20", bin20);
    ar & boost::serialization::make_nvp("bin21", bin21);
    ar & boost::serialization::make_nvp("bin22", bin22);
    ar & boost::serialization::make_nvp("bin23", bin23);
    ar & boost::serialization::make_nvp("bin24", bin24);
    ar & boost::serialization::make_nvp("bin25", bin25);
    ar & boost::serialization::make_nvp("bin26", bin26);
    ar & boost::serialization::make_nvp("bin27", bin27);
    ar & boost::serialization::make_nvp("bin28", bin28);
    ar & boost::serialization::make_nvp("bin29", bin29);
    ar & boost::serialization::make_nvp("bin30", bin30);
    ar & boost::serialization::make_nvp("bin31", bin31);
}
COND_SERIALIZATION_INSTANTIATE(HcalCalibrationQIECoder);

template <class Archive>
void HcalCalibrationQIEData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalCalibrationQIECoder-", boost::serialization::base_object<HcalCondObjectContainer<class HcalCalibrationQIECoder>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalCalibrationQIEData);

template <class Archive>
void HcalChannelQuality::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalChannelStatus-", boost::serialization::base_object<HcalCondObjectContainer<class HcalChannelStatus>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalChannelQuality);

template <class Archive>
void HcalChannelStatus::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mStatus", mStatus);
}
COND_SERIALIZATION_INSTANTIATE(HcalChannelStatus);

template <class Archive>
void HcalCholeskyMatrices::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainerBase", boost::serialization::base_object<HcalCondObjectContainerBase>(*this));
    ar & boost::serialization::make_nvp("HBcontainer", HBcontainer);
    ar & boost::serialization::make_nvp("HEcontainer", HEcontainer);
    ar & boost::serialization::make_nvp("HOcontainer", HOcontainer);
    ar & boost::serialization::make_nvp("HFcontainer", HFcontainer);
}
COND_SERIALIZATION_INSTANTIATE(HcalCholeskyMatrices);

template <class Archive>
void HcalCholeskyMatrix::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cmatrix", cmatrix);
    ar & boost::serialization::make_nvp("mId", mId);
}
COND_SERIALIZATION_INSTANTIATE(HcalCholeskyMatrix);

template <typename Item>
template <class Archive>
void HcalCondObjectContainer<Item>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainerBase", boost::serialization::base_object<HcalCondObjectContainerBase>(*this));
    ar & boost::serialization::make_nvp("HBcontainer", HBcontainer);
    ar & boost::serialization::make_nvp("HEcontainer", HEcontainer);
    ar & boost::serialization::make_nvp("HOcontainer", HOcontainer);
    ar & boost::serialization::make_nvp("HFcontainer", HFcontainer);
    ar & boost::serialization::make_nvp("HTcontainer", HTcontainer);
    ar & boost::serialization::make_nvp("ZDCcontainer", ZDCcontainer);
    ar & boost::serialization::make_nvp("CALIBcontainer", CALIBcontainer);
    ar & boost::serialization::make_nvp("CASTORcontainer", CASTORcontainer);
}

template <class Archive>
void HcalCondObjectContainerBase::serialize(Archive & ar, const unsigned int)
{
}
COND_SERIALIZATION_INSTANTIATE(HcalCondObjectContainerBase);

template <class Archive>
void HcalCovarianceMatrices::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainerBase", boost::serialization::base_object<HcalCondObjectContainerBase>(*this));
    ar & boost::serialization::make_nvp("HBcontainer", HBcontainer);
    ar & boost::serialization::make_nvp("HEcontainer", HEcontainer);
    ar & boost::serialization::make_nvp("HOcontainer", HOcontainer);
    ar & boost::serialization::make_nvp("HFcontainer", HFcontainer);
}
COND_SERIALIZATION_INSTANTIATE(HcalCovarianceMatrices);

template <class Archive>
void HcalCovarianceMatrix::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("covariancematrix", covariancematrix);
}
COND_SERIALIZATION_INSTANTIATE(HcalCovarianceMatrix);

template <class Archive>
void HcalDcsMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mItems", mItems);
}
COND_SERIALIZATION_INSTANTIATE(HcalDcsMap);

template <class Archive>
void HcalDcsMap::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mDcsId", mDcsId);
}
COND_SERIALIZATION_INSTANTIATE(HcalDcsMap::Item);

template <class Archive>
void HcalDcsValue::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mLS", mLS);
    ar & boost::serialization::make_nvp("mValue", mValue);
    ar & boost::serialization::make_nvp("mUpperLimit", mUpperLimit);
    ar & boost::serialization::make_nvp("mLowerLimit", mLowerLimit);
}
COND_SERIALIZATION_INSTANTIATE(HcalDcsValue);

template <class Archive>
void HcalDcsValues::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mHBValues", mHBValues);
    ar & boost::serialization::make_nvp("mHBsorted", mHBsorted);
    ar & boost::serialization::make_nvp("mHEValues", mHEValues);
    ar & boost::serialization::make_nvp("mHEsorted", mHEsorted);
    ar & boost::serialization::make_nvp("mHO0Values", mHO0Values);
    ar & boost::serialization::make_nvp("mHO0sorted", mHO0sorted);
    ar & boost::serialization::make_nvp("mHO12Values", mHO12Values);
    ar & boost::serialization::make_nvp("mHO12sorted", mHO12sorted);
    ar & boost::serialization::make_nvp("mHFValues", mHFValues);
    ar & boost::serialization::make_nvp("mHFsorted", mHFsorted);
}
COND_SERIALIZATION_INSTANTIATE(HcalDcsValues);

template <class Archive>
void HcalElectronicsMap::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mPItems", mPItems);
    ar & boost::serialization::make_nvp("mTItems", mTItems);
}
COND_SERIALIZATION_INSTANTIATE(HcalElectronicsMap);

template <class Archive>
void HcalElectronicsMap::PrecisionItem::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mElId", mElId);
}
COND_SERIALIZATION_INSTANTIATE(HcalElectronicsMap::PrecisionItem);

template <class Archive>
void HcalElectronicsMap::TriggerItem::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mTrigId", mTrigId);
    ar & boost::serialization::make_nvp("mElId", mElId);
}
COND_SERIALIZATION_INSTANTIATE(HcalElectronicsMap::TriggerItem);

template <class Archive>
void HcalFlagHFDigiTimeParam::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mHFdigiflagFirstSample", mHFdigiflagFirstSample);
    ar & boost::serialization::make_nvp("mHFdigiflagSamplesToAdd", mHFdigiflagSamplesToAdd);
    ar & boost::serialization::make_nvp("mHFdigiflagExpectedPeak", mHFdigiflagExpectedPeak);
    ar & boost::serialization::make_nvp("mHFdigiflagMinEthreshold", mHFdigiflagMinEthreshold);
    ar & boost::serialization::make_nvp("mHFdigiflagCoefficients", mHFdigiflagCoefficients);
}
COND_SERIALIZATION_INSTANTIATE(HcalFlagHFDigiTimeParam);

template <class Archive>
void HcalFlagHFDigiTimeParams::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalFlagHFDigiTimeParam-", boost::serialization::base_object<HcalCondObjectContainer<class HcalFlagHFDigiTimeParam>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalFlagHFDigiTimeParams);

template <class Archive>
void HcalGain::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue0", mValue0);
    ar & boost::serialization::make_nvp("mValue1", mValue1);
    ar & boost::serialization::make_nvp("mValue2", mValue2);
    ar & boost::serialization::make_nvp("mValue3", mValue3);
}
COND_SERIALIZATION_INSTANTIATE(HcalGain);

template <class Archive>
void HcalGainWidth::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue0", mValue0);
    ar & boost::serialization::make_nvp("mValue1", mValue1);
    ar & boost::serialization::make_nvp("mValue2", mValue2);
    ar & boost::serialization::make_nvp("mValue3", mValue3);
}
COND_SERIALIZATION_INSTANTIATE(HcalGainWidth);

template <class Archive>
void HcalGainWidths::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalGainWidth-", boost::serialization::base_object<HcalCondObjectContainer<class HcalGainWidth>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalGainWidths);

template <class Archive>
void HcalGains::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalGain-", boost::serialization::base_object<HcalCondObjectContainer<class HcalGain>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalGains);

template <class Archive>
void HcalL1TriggerObject::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mAvrgPed", mAvrgPed);
    ar & boost::serialization::make_nvp("mRespCorrGain", mRespCorrGain);
    ar & boost::serialization::make_nvp("mFlag", mFlag);
}
COND_SERIALIZATION_INSTANTIATE(HcalL1TriggerObject);

template <class Archive>
void HcalL1TriggerObjects::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalL1TriggerObject-", boost::serialization::base_object<HcalCondObjectContainer<class HcalL1TriggerObject>>(*this));
    ar & boost::serialization::make_nvp("mTag", mTag);
    ar & boost::serialization::make_nvp("mAlgo", mAlgo);
}
COND_SERIALIZATION_INSTANTIATE(HcalL1TriggerObjects);

template <class Archive>
void HcalLUTCorr::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue", mValue);
}
COND_SERIALIZATION_INSTANTIATE(HcalLUTCorr);

template <class Archive>
void HcalLUTCorrs::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalLUTCorr-", boost::serialization::base_object<HcalCondObjectContainer<class HcalLUTCorr>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalLUTCorrs);

template <class Archive>
void HcalLongRecoParam::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mSignalTS", mSignalTS);
    ar & boost::serialization::make_nvp("mNoiseTS", mNoiseTS);
}
COND_SERIALIZATION_INSTANTIATE(HcalLongRecoParam);

template <class Archive>
void HcalLongRecoParams::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalLongRecoParam-", boost::serialization::base_object<HcalCondObjectContainer<class HcalLongRecoParam>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalLongRecoParams);

template <class Archive>
void HcalLutMetadata::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalLutMetadatum-", boost::serialization::base_object<HcalCondObjectContainer<class HcalLutMetadatum>>(*this));
    ar & boost::serialization::make_nvp("mNonChannelData", mNonChannelData);
}
COND_SERIALIZATION_INSTANTIATE(HcalLutMetadata);

template <class Archive>
void HcalLutMetadata::NonChannelData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mRctLsb", mRctLsb);
    ar & boost::serialization::make_nvp("mNominalGain", mNominalGain);
}
COND_SERIALIZATION_INSTANTIATE(HcalLutMetadata::NonChannelData);

template <class Archive>
void HcalLutMetadatum::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mRCalib", mRCalib);
    ar & boost::serialization::make_nvp("mLutGranularity", mLutGranularity);
    ar & boost::serialization::make_nvp("mOutputLutThreshold", mOutputLutThreshold);
}
COND_SERIALIZATION_INSTANTIATE(HcalLutMetadatum);

template <class Archive>
void HcalMCParam::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mParam1", mParam1);
}
COND_SERIALIZATION_INSTANTIATE(HcalMCParam);

template <class Archive>
void HcalMCParams::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalMCParam-", boost::serialization::base_object<HcalCondObjectContainer<class HcalMCParam>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalMCParams);

template <class Archive>
void HcalPFCorr::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue", mValue);
}
COND_SERIALIZATION_INSTANTIATE(HcalPFCorr);

template <class Archive>
void HcalPFCorrs::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalPFCorr-", boost::serialization::base_object<HcalCondObjectContainer<class HcalPFCorr>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalPFCorrs);

template <class Archive>
void HcalPedestal::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue0", mValue0);
    ar & boost::serialization::make_nvp("mValue1", mValue1);
    ar & boost::serialization::make_nvp("mValue2", mValue2);
    ar & boost::serialization::make_nvp("mValue3", mValue3);
    ar & boost::serialization::make_nvp("mWidth0", mWidth0);
    ar & boost::serialization::make_nvp("mWidth1", mWidth1);
    ar & boost::serialization::make_nvp("mWidth2", mWidth2);
    ar & boost::serialization::make_nvp("mWidth3", mWidth3);
}
COND_SERIALIZATION_INSTANTIATE(HcalPedestal);

template <class Archive>
void HcalPedestalWidth::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mSigma00", mSigma00);
    ar & boost::serialization::make_nvp("mSigma01", mSigma01);
    ar & boost::serialization::make_nvp("mSigma02", mSigma02);
    ar & boost::serialization::make_nvp("mSigma03", mSigma03);
    ar & boost::serialization::make_nvp("mSigma10", mSigma10);
    ar & boost::serialization::make_nvp("mSigma11", mSigma11);
    ar & boost::serialization::make_nvp("mSigma12", mSigma12);
    ar & boost::serialization::make_nvp("mSigma13", mSigma13);
    ar & boost::serialization::make_nvp("mSigma20", mSigma20);
    ar & boost::serialization::make_nvp("mSigma21", mSigma21);
    ar & boost::serialization::make_nvp("mSigma22", mSigma22);
    ar & boost::serialization::make_nvp("mSigma23", mSigma23);
    ar & boost::serialization::make_nvp("mSigma30", mSigma30);
    ar & boost::serialization::make_nvp("mSigma31", mSigma31);
    ar & boost::serialization::make_nvp("mSigma32", mSigma32);
    ar & boost::serialization::make_nvp("mSigma33", mSigma33);
}
COND_SERIALIZATION_INSTANTIATE(HcalPedestalWidth);

template <class Archive>
void HcalPedestalWidths::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalPedestalWidth-", boost::serialization::base_object<HcalCondObjectContainer<class HcalPedestalWidth>>(*this));
    ar & boost::serialization::make_nvp("unitIsADC", unitIsADC);
}
COND_SERIALIZATION_INSTANTIATE(HcalPedestalWidths);

template <class Archive>
void HcalPedestals::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalPedestal-", boost::serialization::base_object<HcalCondObjectContainer<class HcalPedestal>>(*this));
    ar & boost::serialization::make_nvp("unitIsADC", unitIsADC);
}
COND_SERIALIZATION_INSTANTIATE(HcalPedestals);

template <class Archive>
void HcalQIECoder::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mOffset00", mOffset00);
    ar & boost::serialization::make_nvp("mOffset01", mOffset01);
    ar & boost::serialization::make_nvp("mOffset02", mOffset02);
    ar & boost::serialization::make_nvp("mOffset03", mOffset03);
    ar & boost::serialization::make_nvp("mOffset10", mOffset10);
    ar & boost::serialization::make_nvp("mOffset11", mOffset11);
    ar & boost::serialization::make_nvp("mOffset12", mOffset12);
    ar & boost::serialization::make_nvp("mOffset13", mOffset13);
    ar & boost::serialization::make_nvp("mOffset20", mOffset20);
    ar & boost::serialization::make_nvp("mOffset21", mOffset21);
    ar & boost::serialization::make_nvp("mOffset22", mOffset22);
    ar & boost::serialization::make_nvp("mOffset23", mOffset23);
    ar & boost::serialization::make_nvp("mOffset30", mOffset30);
    ar & boost::serialization::make_nvp("mOffset31", mOffset31);
    ar & boost::serialization::make_nvp("mOffset32", mOffset32);
    ar & boost::serialization::make_nvp("mOffset33", mOffset33);
    ar & boost::serialization::make_nvp("mSlope00", mSlope00);
    ar & boost::serialization::make_nvp("mSlope01", mSlope01);
    ar & boost::serialization::make_nvp("mSlope02", mSlope02);
    ar & boost::serialization::make_nvp("mSlope03", mSlope03);
    ar & boost::serialization::make_nvp("mSlope10", mSlope10);
    ar & boost::serialization::make_nvp("mSlope11", mSlope11);
    ar & boost::serialization::make_nvp("mSlope12", mSlope12);
    ar & boost::serialization::make_nvp("mSlope13", mSlope13);
    ar & boost::serialization::make_nvp("mSlope20", mSlope20);
    ar & boost::serialization::make_nvp("mSlope21", mSlope21);
    ar & boost::serialization::make_nvp("mSlope22", mSlope22);
    ar & boost::serialization::make_nvp("mSlope23", mSlope23);
    ar & boost::serialization::make_nvp("mSlope30", mSlope30);
    ar & boost::serialization::make_nvp("mSlope31", mSlope31);
    ar & boost::serialization::make_nvp("mSlope32", mSlope32);
    ar & boost::serialization::make_nvp("mSlope33", mSlope33);
}
COND_SERIALIZATION_INSTANTIATE(HcalQIECoder);

template <class Archive>
void HcalQIEData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalQIECoder-", boost::serialization::base_object<HcalCondObjectContainer<class HcalQIECoder>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalQIEData);

template <class Archive>
void HcalRecoParam::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mParam1", mParam1);
    ar & boost::serialization::make_nvp("mParam2", mParam2);
}
COND_SERIALIZATION_INSTANTIATE(HcalRecoParam);

template <class Archive>
void HcalRecoParams::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalRecoParam-", boost::serialization::base_object<HcalCondObjectContainer<class HcalRecoParam>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalRecoParams);

template <class Archive>
void HcalRespCorr::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue", mValue);
}
COND_SERIALIZATION_INSTANTIATE(HcalRespCorr);

template <class Archive>
void HcalRespCorrs::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalRespCorr-", boost::serialization::base_object<HcalCondObjectContainer<class HcalRespCorr>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalRespCorrs);

template <class Archive>
void HcalTimeCorr::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue", mValue);
}
COND_SERIALIZATION_INSTANTIATE(HcalTimeCorr);

template <class Archive>
void HcalTimeCorrs::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalTimeCorr-", boost::serialization::base_object<HcalCondObjectContainer<class HcalTimeCorr>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalTimeCorrs);

template <class Archive>
void HcalTimingParam::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("m-nhits", m_nhits);
    ar & boost::serialization::make_nvp("m-phase", m_phase);
    ar & boost::serialization::make_nvp("m-rms", m_rms);
}
COND_SERIALIZATION_INSTANTIATE(HcalTimingParam);

template <class Archive>
void HcalTimingParams::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalTimingParam-", boost::serialization::base_object<HcalCondObjectContainer<class HcalTimingParam>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalTimingParams);

template <class Archive>
void HcalValidationCorr::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue", mValue);
}
COND_SERIALIZATION_INSTANTIATE(HcalValidationCorr);

template <class Archive>
void HcalValidationCorrs::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalValidationCorr-", boost::serialization::base_object<HcalCondObjectContainer<class HcalValidationCorr>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalValidationCorrs);

template <class Archive>
void HcalZDCLowGainFraction::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mValue", mValue);
}
COND_SERIALIZATION_INSTANTIATE(HcalZDCLowGainFraction);

template <class Archive>
void HcalZDCLowGainFractions::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalZDCLowGainFraction-", boost::serialization::base_object<HcalCondObjectContainer<class HcalZDCLowGainFraction>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalZDCLowGainFractions);

template <class Archive>
void HcalZSThreshold::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mId", mId);
    ar & boost::serialization::make_nvp("mLevel", mLevel);
}
COND_SERIALIZATION_INSTANTIATE(HcalZSThreshold);

template <class Archive>
void HcalZSThresholds::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("HcalCondObjectContainer-class-HcalZSThreshold-", boost::serialization::base_object<HcalCondObjectContainer<class HcalZSThreshold>>(*this));
}
COND_SERIALIZATION_INSTANTIATE(HcalZSThresholds);

template <class Archive>
void OOTPileupCorrectionBuffer::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-buffer", m_buffer);
}
COND_SERIALIZATION_INSTANTIATE(OOTPileupCorrectionBuffer);

