
#include "CondFormats/JetMETObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void FFTJetCorrectorParameters::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-buffer", m_buffer);
}
COND_SERIALIZATION_INSTANTIATE(FFTJetCorrectorParameters);

template <class Archive>
void JetCorrectorParameters::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mDefinitions", mDefinitions);
    ar & boost::serialization::make_nvp("mRecords", mRecords);
    ar & boost::serialization::make_nvp("valid-", valid_);
}
COND_SERIALIZATION_INSTANTIATE(JetCorrectorParameters);

template <class Archive>
void JetCorrectorParameters::Definitions::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mIsResponse", mIsResponse);
    ar & boost::serialization::make_nvp("mLevel", mLevel);
    ar & boost::serialization::make_nvp("mFormula", mFormula);
    ar & boost::serialization::make_nvp("mParVar", mParVar);
    ar & boost::serialization::make_nvp("mBinVar", mBinVar);
}
COND_SERIALIZATION_INSTANTIATE(JetCorrectorParameters::Definitions);

template <class Archive>
void JetCorrectorParameters::Record::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mNvar", mNvar);
    ar & boost::serialization::make_nvp("mMin", mMin);
    ar & boost::serialization::make_nvp("mMax", mMax);
    ar & boost::serialization::make_nvp("mParameters", mParameters);
}
COND_SERIALIZATION_INSTANTIATE(JetCorrectorParameters::Record);

template <class Archive>
void JetCorrectorParametersCollection::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("corrections-", corrections_);
    ar & boost::serialization::make_nvp("correctionsL5-", correctionsL5_);
    ar & boost::serialization::make_nvp("correctionsL7-", correctionsL7_);
}
COND_SERIALIZATION_INSTANTIATE(JetCorrectorParametersCollection);

template <class Archive>
void QGLikelihoodCategory::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("RhoMin", RhoMin);
    ar & boost::serialization::make_nvp("RhoMax", RhoMax);
    ar & boost::serialization::make_nvp("PtMin", PtMin);
    ar & boost::serialization::make_nvp("PtMax", PtMax);
    ar & boost::serialization::make_nvp("EtaMin", EtaMin);
    ar & boost::serialization::make_nvp("EtaMax", EtaMax);
    ar & boost::serialization::make_nvp("QGIndex", QGIndex);
    ar & boost::serialization::make_nvp("VarIndex", VarIndex);
}
COND_SERIALIZATION_INSTANTIATE(QGLikelihoodCategory);

template <class Archive>
void QGLikelihoodObject::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("qgValidRange", qgValidRange);
    ar & boost::serialization::make_nvp("data", data);
}
COND_SERIALIZATION_INSTANTIATE(QGLikelihoodObject);

template <class Archive>
void QGLikelihoodObject::Entry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("category", category);
    ar & boost::serialization::make_nvp("histogram", histogram);
    ar & boost::serialization::make_nvp("mean", mean);
}
COND_SERIALIZATION_INSTANTIATE(QGLikelihoodObject::Entry);

template <class Archive>
void QGLikelihoodSystematicsObject::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("data", data);
}
COND_SERIALIZATION_INSTANTIATE(QGLikelihoodSystematicsObject);

template <class Archive>
void QGLikelihoodSystematicsObject::Entry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("systCategory", systCategory);
    ar & boost::serialization::make_nvp("a", a);
    ar & boost::serialization::make_nvp("b", b);
    ar & boost::serialization::make_nvp("lmin", lmin);
    ar & boost::serialization::make_nvp("lmax", lmax);
}
COND_SERIALIZATION_INSTANTIATE(QGLikelihoodSystematicsObject::Entry);

