
#include "CondFormats/Luminosity/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void lumi::BunchCrossingInfo::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("BXIdx", BXIdx);
    ar & boost::serialization::make_nvp("lumivalue", lumivalue);
    ar & boost::serialization::make_nvp("lumierr", lumierr);
    ar & boost::serialization::make_nvp("lumiquality", lumiquality);
}
COND_SERIALIZATION_INSTANTIATE(lumi::BunchCrossingInfo);

template <class Archive>
void lumi::HLTInfo::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("pathname", pathname);
    ar & boost::serialization::make_nvp("inputcount", inputcount);
    ar & boost::serialization::make_nvp("acceptcount", acceptcount);
    ar & boost::serialization::make_nvp("prescale", prescale);
}
COND_SERIALIZATION_INSTANTIATE(lumi::HLTInfo);

template <class Archive>
void lumi::LumiSectionData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-bx", m_bx);
    ar & boost::serialization::make_nvp("m-sectionid", m_sectionid);
    ar & boost::serialization::make_nvp("m-versionid", m_versionid);
    ar & boost::serialization::make_nvp("m-lumiavg", m_lumiavg);
    ar & boost::serialization::make_nvp("m-lumierror", m_lumierror);
    ar & boost::serialization::make_nvp("m-quality", m_quality);
    ar & boost::serialization::make_nvp("m-deadfrac", m_deadfrac);
    ar & boost::serialization::make_nvp("m-startorbit", m_startorbit);
    ar & boost::serialization::make_nvp("m-hlt", m_hlt);
    ar & boost::serialization::make_nvp("m-trigger", m_trigger);
}
COND_SERIALIZATION_INSTANTIATE(lumi::LumiSectionData);

template <class Archive>
void lumi::TriggerInfo::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("name", name);
    ar & boost::serialization::make_nvp("triggercount", triggercount);
    ar & boost::serialization::make_nvp("deadtimecount", deadtimecount);
    ar & boost::serialization::make_nvp("prescale", prescale);
}
COND_SERIALIZATION_INSTANTIATE(lumi::TriggerInfo);

