
#include "CondFormats/OptAlignObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void CSCRSensorData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("sensorType-", sensorType_);
    ar & boost::serialization::make_nvp("sensorNo-", sensorNo_);
    ar & boost::serialization::make_nvp("meLayer-", meLayer_);
    ar & boost::serialization::make_nvp("logicalAlignmentName-", logicalAlignmentName_);
    ar & boost::serialization::make_nvp("cernDesignator-", cernDesignator_);
    ar & boost::serialization::make_nvp("cernBarcode-", cernBarcode_);
    ar & boost::serialization::make_nvp("absSlope-", absSlope_);
    ar & boost::serialization::make_nvp("absSlopeError-", absSlopeError_);
    ar & boost::serialization::make_nvp("normSlope-", normSlope_);
    ar & boost::serialization::make_nvp("normSlopeError-", normSlopeError_);
    ar & boost::serialization::make_nvp("absIntercept-", absIntercept_);
    ar & boost::serialization::make_nvp("absInterceptError-", absInterceptError_);
    ar & boost::serialization::make_nvp("normIntercept-", normIntercept_);
    ar & boost::serialization::make_nvp("normInterceptError-", normInterceptError_);
    ar & boost::serialization::make_nvp("shifts-", shifts_);
}
COND_SERIALIZATION_INSTANTIATE(CSCRSensorData);

template <class Archive>
void CSCRSensors::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cscRSens-", cscRSens_);
}
COND_SERIALIZATION_INSTANTIATE(CSCRSensors);

template <class Archive>
void CSCZSensorData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("sensorType-", sensorType_);
    ar & boost::serialization::make_nvp("sensorNo-", sensorNo_);
    ar & boost::serialization::make_nvp("meLayer-", meLayer_);
    ar & boost::serialization::make_nvp("logicalAlignmentName-", logicalAlignmentName_);
    ar & boost::serialization::make_nvp("cernDesignator-", cernDesignator_);
    ar & boost::serialization::make_nvp("cernBarcode-", cernBarcode_);
    ar & boost::serialization::make_nvp("absSlope-", absSlope_);
    ar & boost::serialization::make_nvp("absSlopeError-", absSlopeError_);
    ar & boost::serialization::make_nvp("normSlope-", normSlope_);
    ar & boost::serialization::make_nvp("normSlopeError-", normSlopeError_);
    ar & boost::serialization::make_nvp("absIntercept-", absIntercept_);
    ar & boost::serialization::make_nvp("absInterceptError-", absInterceptError_);
    ar & boost::serialization::make_nvp("normIntercept-", normIntercept_);
    ar & boost::serialization::make_nvp("normInterceptError-", normInterceptError_);
    ar & boost::serialization::make_nvp("shifts-", shifts_);
}
COND_SERIALIZATION_INSTANTIATE(CSCZSensorData);

template <class Archive>
void CSCZSensors::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cscZSens-", cscZSens_);
}
COND_SERIALIZATION_INSTANTIATE(CSCZSensors);

template <class Archive>
void Inclinometers::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-inclinometers", m_inclinometers);
}
COND_SERIALIZATION_INSTANTIATE(Inclinometers);

template <class Archive>
void Inclinometers::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("Sensor-type", Sensor_type);
    ar & boost::serialization::make_nvp("Sensor-number", Sensor_number);
    ar & boost::serialization::make_nvp("ME-layer", ME_layer);
    ar & boost::serialization::make_nvp("Logical-Alignment-Name", Logical_Alignment_Name);
    ar & boost::serialization::make_nvp("CERN-Designator", CERN_Designator);
    ar & boost::serialization::make_nvp("CERN-Barcode", CERN_Barcode);
    ar & boost::serialization::make_nvp("Inclination-Direction", Inclination_Direction);
    ar & boost::serialization::make_nvp("Abs-Slope", Abs_Slope);
    ar & boost::serialization::make_nvp("Abs-Slope-Error", Abs_Slope_Error);
    ar & boost::serialization::make_nvp("Norm-Slope", Norm_Slope);
    ar & boost::serialization::make_nvp("Norm-Slope-Error", Norm_Slope_Error);
    ar & boost::serialization::make_nvp("Abs-Intercept", Abs_Intercept);
    ar & boost::serialization::make_nvp("Abs-Intercept-Error", Abs_Intercept_Error);
    ar & boost::serialization::make_nvp("Norm-Intercept", Norm_Intercept);
    ar & boost::serialization::make_nvp("Norm-Intercept-Error", Norm_Intercept_Error);
    ar & boost::serialization::make_nvp("Shifts-due-to-shims-etc", Shifts_due_to_shims_etc);
}
COND_SERIALIZATION_INSTANTIATE(Inclinometers::Item);

template <class Archive>
void MBAChBenchCalPlate::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mbaChBenchCalPlate-", mbaChBenchCalPlate_);
}
COND_SERIALIZATION_INSTANTIATE(MBAChBenchCalPlate);

template <class Archive>
void MBAChBenchCalPlateData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("plate-", plate_);
    ar & boost::serialization::make_nvp("side-", side_);
    ar & boost::serialization::make_nvp("object-", object_);
    ar & boost::serialization::make_nvp("posX-", posX_);
    ar & boost::serialization::make_nvp("posY-", posY_);
    ar & boost::serialization::make_nvp("posZ-", posZ_);
    ar & boost::serialization::make_nvp("measDateTime-", measDateTime_);
}
COND_SERIALIZATION_INSTANTIATE(MBAChBenchCalPlateData);

template <class Archive>
void MBAChBenchSurveyPlate::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("mbaChBenchSurveyPlate-", mbaChBenchSurveyPlate_);
}
COND_SERIALIZATION_INSTANTIATE(MBAChBenchSurveyPlate);

template <class Archive>
void MBAChBenchSurveyPlateData::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("edmsID-", edmsID_);
    ar & boost::serialization::make_nvp("surveyCode-", surveyCode_);
    ar & boost::serialization::make_nvp("line-", line_);
    ar & boost::serialization::make_nvp("plate-", plate_);
    ar & boost::serialization::make_nvp("side-", side_);
    ar & boost::serialization::make_nvp("object-", object_);
    ar & boost::serialization::make_nvp("posX-", posX_);
    ar & boost::serialization::make_nvp("posY-", posY_);
    ar & boost::serialization::make_nvp("posZ-", posZ_);
    ar & boost::serialization::make_nvp("measDateTime-", measDateTime_);
}
COND_SERIALIZATION_INSTANTIATE(MBAChBenchSurveyPlateData);

template <class Archive>
void OpticalAlignInfo::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("x-", x_);
    ar & boost::serialization::make_nvp("y-", y_);
    ar & boost::serialization::make_nvp("z-", z_);
    ar & boost::serialization::make_nvp("angx-", angx_);
    ar & boost::serialization::make_nvp("angy-", angy_);
    ar & boost::serialization::make_nvp("angz-", angz_);
    ar & boost::serialization::make_nvp("extraEntries-", extraEntries_);
    ar & boost::serialization::make_nvp("type-", type_);
    ar & boost::serialization::make_nvp("name-", name_);
    ar & boost::serialization::make_nvp("parentName-", parentName_);
    ar & boost::serialization::make_nvp("ID-", ID_);
}
COND_SERIALIZATION_INSTANTIATE(OpticalAlignInfo);

template <class Archive>
void OpticalAlignMeasurementInfo::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("type-", type_);
    ar & boost::serialization::make_nvp("name-", name_);
    ar & boost::serialization::make_nvp("measObjectNames-", measObjectNames_);
    ar & boost::serialization::make_nvp("isSimulatedValue-", isSimulatedValue_);
    ar & boost::serialization::make_nvp("values-", values_);
    ar & boost::serialization::make_nvp("ID-", ID_);
}
COND_SERIALIZATION_INSTANTIATE(OpticalAlignMeasurementInfo);

template <class Archive>
void OpticalAlignMeasurements::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("oaMeasurements-", oaMeasurements_);
}
COND_SERIALIZATION_INSTANTIATE(OpticalAlignMeasurements);

template <class Archive>
void OpticalAlignParam::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("value-", value_);
    ar & boost::serialization::make_nvp("error-", error_);
    ar & boost::serialization::make_nvp("quality-", quality_);
    ar & boost::serialization::make_nvp("name-", name_);
    ar & boost::serialization::make_nvp("dim-type-", dim_type_);
}
COND_SERIALIZATION_INSTANTIATE(OpticalAlignParam);

template <class Archive>
void OpticalAlignments::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("opticalAlignments-", opticalAlignments_);
}
COND_SERIALIZATION_INSTANTIATE(OpticalAlignments);

template <class Archive>
void PXsensors::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-PXsensors", m_PXsensors);
}
COND_SERIALIZATION_INSTANTIATE(PXsensors);

template <class Archive>
void PXsensors::Item::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("Sensor-type", Sensor_type);
    ar & boost::serialization::make_nvp("Sensor-number", Sensor_number);
    ar & boost::serialization::make_nvp("ME-layer", ME_layer);
    ar & boost::serialization::make_nvp("Logical-Alignment-Name", Logical_Alignment_Name);
    ar & boost::serialization::make_nvp("CERN-Designator", CERN_Designator);
    ar & boost::serialization::make_nvp("CERN-Barcode", CERN_Barcode);
    ar & boost::serialization::make_nvp("Abs-Slope", Abs_Slope);
    ar & boost::serialization::make_nvp("Abs-Slope-Error", Abs_Slope_Error);
    ar & boost::serialization::make_nvp("Norm-Slope", Norm_Slope);
    ar & boost::serialization::make_nvp("Norm-Slope-Error", Norm_Slope_Error);
    ar & boost::serialization::make_nvp("Abs-Intercept", Abs_Intercept);
    ar & boost::serialization::make_nvp("Abs-Intercept-Error", Abs_Intercept_Error);
    ar & boost::serialization::make_nvp("Norm-Intercept", Norm_Intercept);
    ar & boost::serialization::make_nvp("Norm-Intercept-Error", Norm_Intercept_Error);
    ar & boost::serialization::make_nvp("Shifts-due-to-shims-etc", Shifts_due_to_shims_etc);
}
COND_SERIALIZATION_INSTANTIATE(PXsensors::Item);

