
#include "CondFormats/PhysicsToolsObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void BinningVariables::serialize(Archive & ar, const unsigned int)
{
}
COND_SERIALIZATION_INSTANTIATE(BinningVariables);

template <class Archive>
void PerformancePayload::serialize(Archive & ar, const unsigned int)
{
}
COND_SERIALIZATION_INSTANTIATE(PerformancePayload);

template <class Archive>
void PerformancePayloadFromBinnedTFormula::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PerformancePayload", boost::serialization::base_object<PerformancePayload>(*this));
    ar & boost::serialization::make_nvp("pls", pls);
    ar & boost::serialization::make_nvp("results-", results_);
    ar & boost::serialization::make_nvp("variables-", variables_);
}
COND_SERIALIZATION_INSTANTIATE(PerformancePayloadFromBinnedTFormula);

template <class Archive>
void PerformancePayloadFromTFormula::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PerformancePayload", boost::serialization::base_object<PerformancePayload>(*this));
    ar & boost::serialization::make_nvp("pl", pl);
    ar & boost::serialization::make_nvp("results-", results_);
    ar & boost::serialization::make_nvp("variables-", variables_);
}
COND_SERIALIZATION_INSTANTIATE(PerformancePayloadFromTFormula);

template <class Archive>
void PerformancePayloadFromTable::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PerformancePayload", boost::serialization::base_object<PerformancePayload>(*this));
    ar & boost::serialization::make_nvp("pl", pl);
    ar & boost::serialization::make_nvp("results-", results_);
    ar & boost::serialization::make_nvp("binning-", binning_);
}
COND_SERIALIZATION_INSTANTIATE(PerformancePayloadFromTable);

template <class Archive>
void PerformanceResult::serialize(Archive & ar, const unsigned int)
{
}
COND_SERIALIZATION_INSTANTIATE(PerformanceResult);

template <class Archive>
void PerformanceWorkingPoint::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("cut-", cut_);
    ar & boost::serialization::make_nvp("dname-", dname_);
}
COND_SERIALIZATION_INSTANTIATE(PerformanceWorkingPoint);

template <class Archive>
void PhysicsPerformancePayload::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("stride-", stride_);
    ar & boost::serialization::make_nvp("table-", table_);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsPerformancePayload);

template <class Archive>
void PhysicsTFormulaPayload::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("limits-", limits_);
    ar & boost::serialization::make_nvp("formulas-", formulas_);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTFormulaPayload);

template <class Archive>
void PhysicsTGraphPayload::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("name-", name_);
    ar & boost::serialization::make_nvp("numPoints-", numPoints_);
    ar & boost::serialization::make_nvp("x-", x_);
    ar & boost::serialization::make_nvp("y-", y_);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTGraphPayload);

template <class Archive>
void PhysicsTools::Calibration::BitSet::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("store", store);
    ar & boost::serialization::make_nvp("bitsInLast", bitsInLast);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::BitSet);

template <typename Value_t, typename AxisX_t, typename AxisY_t>
template <class Archive>
void PhysicsTools::Calibration::Histogram2D<Value_t, AxisX_t, AxisY_t>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("stride", stride);
    ar & boost::serialization::make_nvp("binULimitsX", binULimitsX);
    ar & boost::serialization::make_nvp("binULimitsY", binULimitsY);
    ar & boost::serialization::make_nvp("binValues", binValues);
    ar & boost::serialization::make_nvp("limitsX", limitsX);
    ar & boost::serialization::make_nvp("limitsY", limitsY);
}

template <typename Value_t, typename AxisX_t, typename AxisY_t, typename AxisZ_t>
template <class Archive>
void PhysicsTools::Calibration::Histogram3D<Value_t, AxisX_t, AxisY_t, AxisZ_t>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("strideX", strideX);
    ar & boost::serialization::make_nvp("strideY", strideY);
    ar & boost::serialization::make_nvp("binULimitsX", binULimitsX);
    ar & boost::serialization::make_nvp("binULimitsY", binULimitsY);
    ar & boost::serialization::make_nvp("binULimitsZ", binULimitsZ);
    ar & boost::serialization::make_nvp("binValues", binValues);
    ar & boost::serialization::make_nvp("limitsX", limitsX);
    ar & boost::serialization::make_nvp("limitsY", limitsY);
    ar & boost::serialization::make_nvp("limitsZ", limitsZ);
}

template <typename Value_t, typename Axis_t>
template <class Archive>
void PhysicsTools::Calibration::Histogram<Value_t, Axis_t>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("binULimits", binULimits);
    ar & boost::serialization::make_nvp("binValues", binValues);
    ar & boost::serialization::make_nvp("limits", limits);
}

template <class Archive>
void PhysicsTools::Calibration::MVAComputer::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("inputSet", inputSet);
    ar & boost::serialization::make_nvp("output", output);
    ar & boost::serialization::make_nvp("processors", processors);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::MVAComputer);

template <class Archive>
void PhysicsTools::Calibration::MVAComputerContainer::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("entries", entries);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::MVAComputerContainer);

template <class Archive>
void PhysicsTools::Calibration::Matrix::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("elements", elements);
    ar & boost::serialization::make_nvp("rows", rows);
    ar & boost::serialization::make_nvp("columns", columns);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::Matrix);

template <class Archive>
void PhysicsTools::Calibration::ProcCategory::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("variableBinLimits", variableBinLimits);
    ar & boost::serialization::make_nvp("categoryMapping", categoryMapping);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcCategory);

template <class Archive>
void PhysicsTools::Calibration::ProcClassed::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("nClasses", nClasses);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcClassed);

template <class Archive>
void PhysicsTools::Calibration::ProcCount::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcCount);

template <class Archive>
void PhysicsTools::Calibration::ProcExternal::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("method", method);
    ar & boost::serialization::make_nvp("store", store);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcExternal);

template <class Archive>
void PhysicsTools::Calibration::ProcForeach::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("nProcs", nProcs);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcForeach);

template <class Archive>
void PhysicsTools::Calibration::ProcLikelihood::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("pdfs", pdfs);
    ar & boost::serialization::make_nvp("bias", bias);
    ar & boost::serialization::make_nvp("categoryIdx", categoryIdx);
    ar & boost::serialization::make_nvp("logOutput", logOutput);
    ar & boost::serialization::make_nvp("individual", individual);
    ar & boost::serialization::make_nvp("neverUndefined", neverUndefined);
    ar & boost::serialization::make_nvp("keepEmpty", keepEmpty);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcLikelihood);

template <class Archive>
void PhysicsTools::Calibration::ProcLikelihood::SigBkg::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("background", background);
    ar & boost::serialization::make_nvp("signal", signal);
    ar & boost::serialization::make_nvp("useSplines", useSplines);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcLikelihood::SigBkg);

template <class Archive>
void PhysicsTools::Calibration::ProcLinear::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("coeffs", coeffs);
    ar & boost::serialization::make_nvp("offset", offset);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcLinear);

template <class Archive>
void PhysicsTools::Calibration::ProcMLP::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("layers", layers);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcMLP);

template <class Archive>
void PhysicsTools::Calibration::ProcMatrix::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("matrix", matrix);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcMatrix);

template <class Archive>
void PhysicsTools::Calibration::ProcMultiply::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("in", in);
    ar & boost::serialization::make_nvp("out", out);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcMultiply);

template <class Archive>
void PhysicsTools::Calibration::ProcNormalize::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("distr", distr);
    ar & boost::serialization::make_nvp("categoryIdx", categoryIdx);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcNormalize);

template <class Archive>
void PhysicsTools::Calibration::ProcOptional::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("neutralPos", neutralPos);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcOptional);

template <class Archive>
void PhysicsTools::Calibration::ProcSort::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("sortByIndex", sortByIndex);
    ar & boost::serialization::make_nvp("descending", descending);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcSort);

template <class Archive>
void PhysicsTools::Calibration::ProcSplitter::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("PhysicsTools::Calibration::VarProcessor", boost::serialization::base_object<PhysicsTools::Calibration::VarProcessor>(*this));
    ar & boost::serialization::make_nvp("nFirst", nFirst);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::ProcSplitter);

template <typename Axis_t>
template <class Archive>
void PhysicsTools::Calibration::Range<Axis_t>::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("min", min);
    ar & boost::serialization::make_nvp("max", max);
}

template <class Archive>
void PhysicsTools::Calibration::VHistogramD2D::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("vHist", vHist);
    ar & boost::serialization::make_nvp("vValues", vValues);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::VHistogramD2D);

template <class Archive>
void PhysicsTools::Calibration::VarProcessor::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("inputVars", inputVars);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::VarProcessor);

template <class Archive>
void PhysicsTools::Calibration::Variable::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("name", name);
}
COND_SERIALIZATION_INSTANTIATE(PhysicsTools::Calibration::Variable);

#include "CondFormats/PhysicsToolsObjects/src/SerializationManual.h"
