
#include "CondFormats/RecoMuonObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void DYTParamObject::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-id", m_id);
    ar & boost::serialization::make_nvp("m-params", m_params);
}
COND_SERIALIZATION_INSTANTIATE(DYTParamObject);

template <class Archive>
void DYTParamsObject::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-paramObjs", m_paramObjs);
    ar & boost::serialization::make_nvp("m-formula", m_formula);
}
COND_SERIALIZATION_INSTANTIATE(DYTParamsObject);

template <class Archive>
void DYTThrObject::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("thrsVec", thrsVec);
}
COND_SERIALIZATION_INSTANTIATE(DYTThrObject);

template <class Archive>
void DYTThrObject::DytThrStruct::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("id", id);
    ar & boost::serialization::make_nvp("thr", thr);
}
COND_SERIALIZATION_INSTANTIATE(DYTThrObject::DytThrStruct);

template <class Archive>
void MuScleFitDBobject::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("identifiers", identifiers);
    ar & boost::serialization::make_nvp("parameters", parameters);
    ar & boost::serialization::make_nvp("fitQuality", fitQuality);
}
COND_SERIALIZATION_INSTANTIATE(MuScleFitDBobject);

