
#include "CondFormats/SiStripObjects/src/headers.h"

#include <boost/serialization/base_object.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#include "CondFormats/Serialization/interface/Equal.h"
#include "CondFormats/Serialization/interface/Instantiate.h"

template <class Archive>
void FedChannelConnection::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("fecCrate-", fecCrate_);
    ar & boost::serialization::make_nvp("fecSlot-", fecSlot_);
    ar & boost::serialization::make_nvp("fecRing-", fecRing_);
    ar & boost::serialization::make_nvp("ccuAddr-", ccuAddr_);
    ar & boost::serialization::make_nvp("ccuChan-", ccuChan_);
    ar & boost::serialization::make_nvp("apv0-", apv0_);
    ar & boost::serialization::make_nvp("apv1-", apv1_);
    ar & boost::serialization::make_nvp("dcuId-", dcuId_);
    ar & boost::serialization::make_nvp("detId-", detId_);
    ar & boost::serialization::make_nvp("nApvPairs-", nApvPairs_);
    ar & boost::serialization::make_nvp("fedCrate-", fedCrate_);
    ar & boost::serialization::make_nvp("fedSlot-", fedSlot_);
    ar & boost::serialization::make_nvp("fedId-", fedId_);
    ar & boost::serialization::make_nvp("fedCh-", fedCh_);
    ar & boost::serialization::make_nvp("length-", length_);
    ar & boost::serialization::make_nvp("dcu0x00-", dcu0x00_);
    ar & boost::serialization::make_nvp("mux0x43-", mux0x43_);
    ar & boost::serialization::make_nvp("pll0x44-", pll0x44_);
    ar & boost::serialization::make_nvp("lld0x60-", lld0x60_);
}
COND_SERIALIZATION_INSTANTIATE(FedChannelConnection);

template <class Archive>
void Phase2TrackerCabling::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("connections-", connections_);
}
COND_SERIALIZATION_INSTANTIATE(Phase2TrackerCabling);

template <class Archive>
void Phase2TrackerModule::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("moduleType-", moduleType_);
    ar & boost::serialization::make_nvp("detid-", detid_);
    ar & boost::serialization::make_nvp("gbtid-", gbtid_);
    ar & boost::serialization::make_nvp("powerGroup-", powerGroup_);
    ar & boost::serialization::make_nvp("coolingLoop-", coolingLoop_);
    ar & boost::serialization::make_nvp("ch-", ch_);
    ar & boost::serialization::make_nvp("i2cDevices-", i2cDevices_);
}
COND_SERIALIZATION_INSTANTIATE(Phase2TrackerModule);

template <class Archive>
void SiStripApvGain::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("v-gains", v_gains);
    ar & boost::serialization::make_nvp("v-detids", v_detids);
    ar & boost::serialization::make_nvp("v-ibegin", v_ibegin);
    ar & boost::serialization::make_nvp("v-iend", v_iend);
}
COND_SERIALIZATION_INSTANTIATE(SiStripApvGain);

template <class Archive>
void SiStripBackPlaneCorrection::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-BPC", m_BPC);
}
COND_SERIALIZATION_INSTANTIATE(SiStripBackPlaneCorrection);

template <class Archive>
void SiStripBadStrip::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("v-badstrips", v_badstrips);
    ar & boost::serialization::make_nvp("indexes", indexes);
}
COND_SERIALIZATION_INSTANTIATE(SiStripBadStrip);

template <class Archive>
void SiStripBadStrip::DetRegistry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detid", detid);
    ar & boost::serialization::make_nvp("ibegin", ibegin);
    ar & boost::serialization::make_nvp("iend", iend);
}
COND_SERIALIZATION_INSTANTIATE(SiStripBadStrip::DetRegistry);

template <class Archive>
void SiStripBaseDelay::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("delays-", delays_);
}
COND_SERIALIZATION_INSTANTIATE(SiStripBaseDelay);

template <class Archive>
void SiStripBaseDelay::Delay::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detId", detId);
    ar & boost::serialization::make_nvp("coarseDelay", coarseDelay);
    ar & boost::serialization::make_nvp("fineDelay", fineDelay);
}
COND_SERIALIZATION_INSTANTIATE(SiStripBaseDelay::Delay);

template <class Archive>
void SiStripConfObject::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("parameters", parameters);
}
COND_SERIALIZATION_INSTANTIATE(SiStripConfObject);

template <class Archive>
void SiStripDetVOff::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("v-Voff", v_Voff);
}
COND_SERIALIZATION_INSTANTIATE(SiStripDetVOff);

template <class Archive>
void SiStripFedCabling::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("feds-", feds_);
    ar & boost::serialization::make_nvp("registry-", registry_);
    ar & boost::serialization::make_nvp("connections-", connections_);
    ar & boost::serialization::make_nvp("detected-", detected_);
    ar & boost::serialization::make_nvp("undetected-", undetected_);
}
COND_SERIALIZATION_INSTANTIATE(SiStripFedCabling);

template <class Archive>
void SiStripLatency::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("latencies-", latencies_);
}
COND_SERIALIZATION_INSTANTIATE(SiStripLatency);

template <class Archive>
void SiStripLatency::Latency::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detIdAndApv", detIdAndApv);
    ar & boost::serialization::make_nvp("latency", latency);
    ar & boost::serialization::make_nvp("mode", mode);
}
COND_SERIALIZATION_INSTANTIATE(SiStripLatency::Latency);

template <class Archive>
void SiStripLorentzAngle::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("m-LA", m_LA);
}
COND_SERIALIZATION_INSTANTIATE(SiStripLorentzAngle);

template <class Archive>
void SiStripNoises::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("v-noises", v_noises);
    ar & boost::serialization::make_nvp("indexes", indexes);
}
COND_SERIALIZATION_INSTANTIATE(SiStripNoises);

template <class Archive>
void SiStripNoises::DetRegistry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detid", detid);
    ar & boost::serialization::make_nvp("ibegin", ibegin);
    ar & boost::serialization::make_nvp("iend", iend);
}
COND_SERIALIZATION_INSTANTIATE(SiStripNoises::DetRegistry);

template <class Archive>
void SiStripPedestals::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("v-pedestals", v_pedestals);
    ar & boost::serialization::make_nvp("indexes", indexes);
}
COND_SERIALIZATION_INSTANTIATE(SiStripPedestals);

template <class Archive>
void SiStripPedestals::DetRegistry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detid", detid);
    ar & boost::serialization::make_nvp("ibegin", ibegin);
    ar & boost::serialization::make_nvp("iend", iend);
}
COND_SERIALIZATION_INSTANTIATE(SiStripPedestals::DetRegistry);

template <class Archive>
void SiStripRunSummary::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("runSummary-", runSummary_);
}
COND_SERIALIZATION_INSTANTIATE(SiStripRunSummary);

template <class Archive>
void SiStripSummary::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("userDBContent-", userDBContent_);
    ar & boost::serialization::make_nvp("v-sum-", v_sum_);
    ar & boost::serialization::make_nvp("indexes-", indexes_);
    ar & boost::serialization::make_nvp("runNr-", runNr_);
    ar & boost::serialization::make_nvp("timeValue-", timeValue_);
}
COND_SERIALIZATION_INSTANTIATE(SiStripSummary);

template <class Archive>
void SiStripSummary::DetRegistry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detid", detid);
    ar & boost::serialization::make_nvp("ibegin", ibegin);
}
COND_SERIALIZATION_INSTANTIATE(SiStripSummary::DetRegistry);

template <class Archive>
void SiStripThreshold::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("v-threshold", v_threshold);
    ar & boost::serialization::make_nvp("indexes", indexes);
}
COND_SERIALIZATION_INSTANTIATE(SiStripThreshold);

template <class Archive>
void SiStripThreshold::Data::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("FirstStrip-and-Hth", FirstStrip_and_Hth);
    ar & boost::serialization::make_nvp("lowTh", lowTh);
    ar & boost::serialization::make_nvp("clusTh", clusTh);
}
COND_SERIALIZATION_INSTANTIATE(SiStripThreshold::Data);

template <class Archive>
void SiStripThreshold::DetRegistry::serialize(Archive & ar, const unsigned int)
{
    ar & boost::serialization::make_nvp("detid", detid);
    ar & boost::serialization::make_nvp("ibegin", ibegin);
    ar & boost::serialization::make_nvp("iend", iend);
}
COND_SERIALIZATION_INSTANTIATE(SiStripThreshold::DetRegistry);

